## atlas 3.10.1

=== Makefile ===
#######################################################################
#  This makefile runs the test programs for the linear equation routines
#  and the eigenvalue routines in LAPACK.  The test output files
#  are grouped as follows:
#
#       SLINTST,SEIGTST  -- Single precision real test routines
#       CLINTST,CEIGTST  -- Single precision complex test routines
#       DLINTST,DEIGTST  -- Double precision real test routines
#       ZLINTST,ZEIGTST  -- Double precision complex test routines
#
#  Test programs can be executed for all or some of the four different
#  precisions.  Enter 'make' followed by one or more of the data types
#  desired.
#  Some examples:
#       make single
#       make single complex
#       make single double complex complex16
#  Alternatively, the command
#       make
#  without any arguments runs all eight test programs.
#  The executable files are called:
#       xlintsts, xlintstd, xlintstc, and xlintstz for LIN
#       xeigtsts, xeigtstd, xeigtstc, and xeigtstz for EIG
#  and exist in the current directory level.
#
#  To remove the output files after the tests have been run, enter
#       make clean
#
#  To re-run specific tests after a make, enter (for example):
#       'rm ssvd.out; make'  or:
#       'make ssvd.out' or:
#       'touch svd.in; make' (to re-run the single precision SVD tests.)
#
#       'rm *svd.out; make'  (to re-run all the SVD tests.)
#
#######################################################################

include ../Make.inc
LAPACKLIB = $(LAPACKlib)
BLASLIB = $(F77BLASlib) $(CBLASlib) $(ATLASlib)

ATL_all :
	cd MATGEN ; $(MAKE)
	cd LIN ; $(MAKE) LAPACKLIB="$(LAPACKLIB)" BLASLIB="$(BLASLIB)"
	cd EIG ; $(MAKE) LAPACKLIB="$(LAPACKLIB)" BLASLIB="$(BLASLIB)"
	$(MAKE) all LAPACKLIB="$(LAPACKLIB)" BLASLIB="$(BLASLIB)"

all: single complex double complex16 singleproto doubleproto \
     complexproto complex16proto

SEIGTST= snep.out \
         ssep.out \
         ssvd.out \
         sec.out \
         sed.out \
         sgg.out \
         sgd.out \
         ssb.out \
	 ssg.out \
         sbal.out \
         sbak.out \
         sgbal.out \
         sgbak.out \
         sbb.out \
         sglm.out \
         sgqr.out \
         sgsv.out \
         scsd.out \
         slse.out

CEIGTST= cnep.out \
         csep.out \
         csvd.out \
         cec.out \
         ced.out \
         cgg.out \
         cgd.out \
         csb.out \
	 csg.out \
         cbal.out \
         cbak.out \
         cgbal.out \
         cgbak.out \
         cbb.out \
         cglm.out \
         cgqr.out \
         cgsv.out \
         ccsd.out \
         clse.out

DEIGTST= dnep.out \
         dsep.out \
         dsvd.out \
         dec.out \
         ded.out \
         dgg.out \
         dgd.out \
         dsb.out \
	 dsg.out \
         dbal.out \
         dbak.out \
         dgbal.out \
         dgbak.out \
         dbb.out \
         dglm.out \
         dgqr.out \
         dgsv.out \
         dcsd.out \
         dlse.out

ZEIGTST= znep.out \
         zsep.out \
         zsvd.out \
         zec.out \
         zed.out \
         zgg.out \
         zgd.out \
         zsb.out \
	 zsg.out \
         zbal.out \
         zbak.out \
         zgbal.out \
         zgbak.out \
         zbb.out \
         zglm.out \
         zgqr.out \
         zgsv.out \
         zcsd.out \
         zlse.out


SLINTST= stest.out

SLINTSTPROTO= stest_rfp.out

CLINTST= ctest.out

CLINTSTPROTO= ctest_rfp.out

DLINTST= dtest.out

DLINTSTPROTO= dstest.out dtest_rfp.out

ZLINTST= ztest.out

ZLINTSTPROTO= zctest.out ztest_rfp.out

single:         $(SLINTST) $(SEIGTST)
complex:        $(CLINTST) $(CEIGTST)
double:         $(DLINTST) $(DEIGTST)
complex16:      $(ZLINTST) $(ZEIGTST)
singleproto:    $(SLINTSTPROTO)
complexproto:   $(CLINTSTPROTO)
doubleproto:    $(DLINTSTPROTO)
complex16proto: $(ZLINTSTPROTO)

#
# ======== SINGLE LIN TESTS ===========================

stest.out: stest.in xlintsts
	@echo Testing REAL LAPACK linear equation routines
	./xlintsts < stest.in > $@ 2>&1
#
# ======== COMPLEX LIN TESTS ==========================

ctest.out: ctest.in xlintstc
	@echo Testing COMPLEX LAPACK linear equation routines
	./xlintstc < ctest.in > $@ 2>&1
#
# ======== DOUBLE LIN TESTS ===========================

dtest.out: dtest.in xlintstd
	@echo Testing DOUBLE PRECISION LAPACK linear equation routines
	./xlintstd < dtest.in > $@ 2>&1
#
# ======== COMPLEX16 LIN TESTS ========================

ztest.out: ztest.in xlintstz
	@echo Testing COMPLEX16 LAPACK linear equation routines
	./xlintstz < ztest.in > $@ 2>&1
#
# ======== SINGLE-DOUBLE PROTO LIN TESTS ==============

dstest.out: dstest.in xlintstds
	@echo Testing SINGLE-DOUBLE PRECISION LAPACK prototype linear equation routines
	./xlintstds < dstest.in > $@ 2>&1
#
# ======== COMPLEX-COMPLEX16 LIN TESTS ========================

zctest.out: zctest.in xlintstzc
	@echo Testing COMPLEX-COMPLEX16 LAPACK protoype linear equation routines
	./xlintstzc < zctest.in > $@ 2>&1
#
# ======== SINGLE RFP LIN TESTS ========================

stest_rfp.out: stest_rfp.in xlintstrfs
	@echo Testing REAL LAPACK RFP protoype linear equation routines
	./xlintstrfs < stest_rfp.in > $@ 2>&1
#
# ======== COMPLEX16 RFP LIN TESTS ========================

dtest_rfp.out: dtest_rfp.in xlintstrfd
	@echo Testing DOUBLE PRECISION LAPACK RFP protoype linear equation routines
	./xlintstrfd < dtest_rfp.in > $@ 2>&1
#
# ======== COMPLEX16 RFP LIN TESTS ========================

ctest_rfp.out: ctest_rfp.in xlintstrfc
	@echo Testing COMPLEX LAPACK RFP protoype linear equation routines
	./xlintstrfc < ctest_rfp.in > $@ 2>&1
#
# ======== COMPLEX16 RFP LIN TESTS ========================

ztest_rfp.out: ztest_rfp.in xlintstrfz
	@echo Testing COMPLEX16 LAPACK RFP protoype linear equation routines
	./xlintstrfz < ztest_rfp.in > $@ 2>&1
#
#
# ======== SINGLE EIG TESTS ===========================
#

snep.out: nep.in xeigtsts
	@echo NEP: Testing Nonsymmetric Eigenvalue Problem routines
	./xeigtsts < nep.in > $@ 2>&1

ssep.out: sep.in xeigtsts
	@echo SEP: Testing Symmetric Eigenvalue Problem routines
	./xeigtsts < sep.in > $@ 2>&1

ssvd.out: svd.in xeigtsts
	@echo SVD: Testing Singular Value Decomposition routines
	./xeigtsts < svd.in > $@ 2>&1

sec.out: sec.in xeigtsts
	@echo SEC: Testing REAL Eigen Condition Routines
	./xeigtsts < sec.in > $@ 2>&1

sed.out: sed.in xeigtsts
	@echo SEV: Testing REAL Nonsymmetric Eigenvalue Driver
	./xeigtsts < sed.in > $@ 2>&1

sgg.out: sgg.in xeigtsts
	@echo SGG: Testing REAL Nonsymmetric Generalized Eigenvalue Problem routines
	./xeigtsts < sgg.in > $@ 2>&1

sgd.out: sgd.in xeigtsts
	@echo SGD: Testing REAL Nonsymmetric Generalized Eigenvalue Problem driver routines
	./xeigtsts < sgd.in > $@ 2>&1

ssb.out: ssb.in xeigtsts
	@echo SSB: Testing REAL Symmetric Eigenvalue Problem routines
	./xeigtsts < ssb.in > $@ 2>&1

ssg.out: ssg.in xeigtsts
	@echo SSG: Testing REAL Symmetric Generalized Eigenvalue Problem routines
	./xeigtsts < ssg.in > $@ 2>&1

sbal.out: sbal.in xeigtsts
	@echo SGEBAL: Testing the balancing of a REAL general matrix
	./xeigtsts < sbal.in > $@ 2>&1

sbak.out: sbak.in xeigtsts
	@echo SGEBAK: Testing the back transformation of a REAL balanced matrix
	./xeigtsts < sbak.in > $@ 2>&1

sgbal.out: sgbal.in xeigtsts
	@echo SGGBAL: Testing the balancing of a pair of REAL general matrices
	./xeigtsts < sgbal.in > $@ 2>&1

sgbak.out: sgbak.in xeigtsts
	@echo SGGBAK: Testing the back transformation of a pair of REAL balanced matrices
	./xeigtsts < sgbak.in > $@ 2>&1

sbb.out: sbb.in xeigtsts
	@echo SBB:  Testing banded Singular Value Decomposition routines
	./xeigtsts < sbb.in > $@ 2>&1

sglm.out: glm.in xeigtsts
	@echo GLM: Testing Generalized Linear Regression Model routines
	./xeigtsts < glm.in > $@ 2>&1

sgqr.out: gqr.in xeigtsts
	@echo GQR: Testing Generalized QR and RQ factorization routines
	./xeigtsts < gqr.in > $@ 2>&1

sgsv.out: gsv.in xeigtsts
	@echo GSV: Testing Generalized Singular Value Decomposition routines
	./xeigtsts < gsv.in > $@ 2>&1

scsd.out: csd.in xeigtsts
	@echo CSD: Testing CS Decomposition routines
	./xeigtsts < csd.in > $@ 2>&1

slse.out: lse.in xeigtsts
	@echo LSE: Testing Constrained Linear Least Squares routines
	./xeigtsts < lse.in > $@ 2>&1
#
# ======== COMPLEX EIG TESTS ===========================

cnep.out: nep.in xeigtstc
	@echo NEP: Testing Nonsymmetric Eigenvalue Problem routines
	./xeigtstc < nep.in > $@ 2>&1

csep.out: sep.in xeigtstc
	@echo SEP: Testing Symmetric Eigenvalue Problem routines
	./xeigtstc < sep.in > $@ 2>&1

csvd.out: svd.in xeigtstc
	@echo SVD: Testing Singular Value Decomposition routines
	./xeigtstc < svd.in > $@ 2>&1

cec.out: cec.in xeigtstc
	@echo CEC: Testing COMPLEX Eigen Condition Routines
	./xeigtstc < cec.in > $@ 2>&1

ced.out: ced.in xeigtstc
	@echo CES: Testing COMPLEX Nonsymmetric Schur Form Driver
	./xeigtstc < ced.in > $@ 2>&1

cgg.out: cgg.in xeigtstc
	@echo CGG: Testing COMPLEX Nonsymmetric Generalized Eigenvalue Problem routines
	./xeigtstc < cgg.in > $@ 2>&1

cgd.out: cgd.in xeigtstc
	@echo CGD: Testing COMPLEX Nonsymmetric Generalized Eigenvalue Problem driver routines
	./xeigtstc < cgd.in > $@ 2>&1

csb.out: csb.in xeigtstc
	@echo CHB: Testing Hermitian Eigenvalue Problem routines
	./xeigtstc < csb.in > $@ 2>&1

csg.out: csg.in xeigtstc
	@echo CSG: Testing Symmetric Generalized Eigenvalue Problem routines
	./xeigtstc < csg.in > $@ 2>&1

cbal.out: cbal.in xeigtstc
	@echo CGEBAL: Testing the balancing of a COMPLEX general matrix
	./xeigtstc < cbal.in > $@ 2>&1

cbak.out: cbak.in xeigtstc
	@echo CGEBAK: Testing the back transformation of a COMPLEX balanced matrix
	./xeigtstc < cbak.in > $@ 2>&1

cgbal.out: cgbal.in xeigtstc
	@echo CGGBAL: Testing the balancing of a pair of COMPLEX general matrices
	./xeigtstc < cgbal.in > $@ 2>&1

cgbak.out: cgbak.in xeigtstc
	@echo CGGBAK: Testing the back transformation of a pair of COMPLEX balanced matrices
	./xeigtstc < cgbak.in > $@ 2>&1

cbb.out: cbb.in xeigtstc
	@echo CBB:  Testing banded Singular Value Decomposition routines
	./xeigtstc < cbb.in > $@ 2>&1

cglm.out: glm.in xeigtstc
	@echo GLM: Testing Generalized Linear Regression Model routines
	./xeigtstc < glm.in > $@ 2>&1

cgqr.out: gqr.in xeigtstc
	@echo GQR: Testing Generalized QR and RQ factorization routines
	./xeigtstc < gqr.in > $@ 2>&1

cgsv.out: gsv.in xeigtstc
	@echo GSV: Testing Generalized Singular Value Decomposition routines
	./xeigtstc < gsv.in > $@ 2>&1

ccsd.out: csd.in xeigtstc
	@echo CSD: Testing CS Decomposition routines
	./xeigtstc < csd.in > $@ 2>&1

clse.out: lse.in xeigtstc
	@echo LSE: Testing Constrained Linear Least Squares routines
	./xeigtstc < lse.in > $@ 2>&1
#
# ======== DOUBLE EIG TESTS ===========================

dnep.out: nep.in xeigtstd
	@echo NEP: Testing Nonsymmetric Eigenvalue Problem routines
	./xeigtstd < nep.in > $@ 2>&1

dsep.out: sep.in xeigtstd
	@echo SEP: Testing Symmetric Eigenvalue Problem routines
	./xeigtstd < sep.in > $@ 2>&1

dsvd.out: svd.in xeigtstd
	@echo SVD: Testing Singular Value Decomposition routines
	./xeigtstd < svd.in > $@ 2>&1

dec.out: dec.in xeigtstd
	@echo DEC: Testing DOUBLE PRECISION Eigen Condition Routines
	./xeigtstd < dec.in > $@ 2>&1

ded.out: ded.in xeigtstd
	@echo DEV: Testing DOUBLE PRECISION Nonsymmetric Eigenvalue Driver
	./xeigtstd < ded.in > $@ 2>&1

dgg.out: dgg.in xeigtstd
	@echo DGG: Testing DOUBLE PRECISION Nonsymmetric Generalized Eigenvalue Problem routines
	./xeigtstd < dgg.in > $@ 2>&1

dgd.out: dgd.in xeigtstd
	@echo DGD: Testing DOUBLE PRECISION Nonsymmetric Generalized Eigenvalue Problem driver routines
	./xeigtstd < dgd.in > $@ 2>&1

dsb.out: dsb.in xeigtstd
	@echo DSB: Testing DOUBLE PRECISION Symmetric Eigenvalue Problem routines
	./xeigtstd < dsb.in > $@ 2>&1

dsg.out: dsg.in xeigtstd
	@echo DSG: Testing DOUBLE PRECISION Symmetric Generalized Eigenvalue Problem routines
	./xeigtstd < dsg.in > $@ 2>&1

dbal.out: dbal.in xeigtstd

=== EIG/CMakeLists.txt ===
########################################################################
#  This is the makefile for the eigenvalue test program from LAPACK.
#  The test files are organized as follows:
#
#     AEIGTST -- Auxiliary test routines used in all precisions
#     SCIGTST -- Auxiliary test routines used in REAL and COMPLEX
#     DZIGTST -- Auxiliary test routines used in DOUBLE PRECISION and
#                COMPLEX*16
#     SEIGTST -- Single precision real test routines
#     CEIGTST -- Single precision complex test routines
#     DEIGTST -- Double precision real test routines
#     ZEIGTST -- Double precision complex test routines
#
#  Test programs can be generated for all or some of the four different
#  precisions.  Enter make followed by one or more of the data types
#  desired.  Some examples:
#       make single
#       make single complex
#       make single double complex complex16
#  Alternatively, the command
#       make
#  without any arguments creates all four test programs.
#  The executable files are called
#       xeigtsts, xeigtstd, xeigtstc, and xeigtstz
#  and are created in the next higher directory level.
#
#  To remove the object files after the executable files have been
#  created, enter
#       make clean
#  On some systems, you can force the source files to be recompiled by
#  entering (for example)
#       make single FRC=FRC
#
########################################################################

set(AEIGTST  
   alahdg.f 
   alasum.f 
   alasvm.f 
   alareq.f 
   ilaenv.f 
   xerbla.f 
   xlaenv.f 
   chkxer.f)

set(SCIGTST  slafts.f slahd2.f slasum.f slatb9.f sstech.f sstect.f 
   ssvdch.f ssvdct.f ssxt1.f)

set(SEIGTST  schkee.f 
   sbdt01.f sbdt02.f sbdt03.f 
   schkbb.f schkbd.f schkbk.f schkbl.f schkec.f 
   schkgg.f schkgk.f schkgl.f schkhs.f schksb.f schkst.f 
   sckcsd.f sckglm.f sckgqr.f sckgsv.f scklse.f scsdts.f
   sdrges.f sdrgev.f sdrgsx.f sdrgvx.f 
   sdrvbd.f sdrves.f sdrvev.f sdrvgg.f sdrvsg.f 
   sdrvst.f sdrvsx.f sdrvvx.f 
   serrbd.f serrec.f serred.f serrgg.f serrhs.f serrst.f 
   sget02.f sget10.f sget22.f sget23.f sget24.f sget31.f 
   sget32.f sget33.f sget34.f sget35.f sget36.f 
   sget37.f sget38.f sget39.f sget51.f sget52.f sget53.f 
   sget54.f sglmts.f sgqrts.f sgrqts.f sgsvts.f 
   shst01.f slarfy.f slarhs.f slatm4.f slctes.f slctsx.f slsets.f sort01.f 
   sort03.f ssbt21.f ssgt01.f sslect.f sspt21.f sstt21.f 
   sstt22.f ssyt21.f ssyt22.f)

set(CEIGTST  cchkee.f 
   cbdt01.f cbdt02.f cbdt03.f 
   cchkbb.f cchkbd.f cchkbk.f cchkbl.f cchkec.f 
   cchkgg.f cchkgk.f cchkgl.f cchkhb.f cchkhs.f cchkst.f 
   cckcsd.f cckglm.f cckgqr.f cckgsv.f ccklse.f ccsdts.f
   cdrges.f cdrgev.f cdrgsx.f cdrgvx.f 
   cdrvbd.f cdrves.f cdrvev.f cdrvgg.f cdrvsg.f 
   cdrvst.f cdrvsx.f cdrvvx.f 
   cerrbd.f cerrec.f cerred.f cerrgg.f cerrhs.f cerrst.f 
   cget02.f cget10.f cget22.f cget23.f cget24.f 
   cget35.f cget36.f cget37.f cget38.f cget51.f cget52.f 
   cget54.f cglmts.f cgqrts.f cgrqts.f cgsvts.f 
   chbt21.f chet21.f chet22.f chpt21.f chst01.f 
   clarfy.f clarhs.f clatm4.f clctes.f clctsx.f clsets.f csbmv.f 
   csgt01.f cslect.f 
   cstt21.f cstt22.f cunt01.f cunt03.f)

set(DZIGTST  dlafts.f dlahd2.f dlasum.f dlatb9.f dstech.f dstect.f 
   dsvdch.f dsvdct.f dsxt1.f)

set(DEIGTST  dchkee.f 
   dbdt01.f dbdt02.f dbdt03.f 
   dchkbb.f dchkbd.f dchkbk.f dchkbl.f dchkec.f 
   dchkgg.f dchkgk.f dchkgl.f dchkhs.f dchksb.f dchkst.f 
   dckcsd.f dckglm.f dckgqr.f dckgsv.f dcklse.f dcsdts.f
   ddrges.f ddrgev.f ddrgsx.f ddrgvx.f 
   ddrvbd.f ddrves.f ddrvev.f ddrvgg.f ddrvsg.f 
   ddrvst.f ddrvsx.f ddrvvx.f 
   derrbd.f derrec.f derred.f derrgg.f derrhs.f derrst.f 
   dget02.f dget10.f dget22.f dget23.f dget24.f dget31.f 
   dget32.f dget33.f dget34.f dget35.f dget36.f 
   dget37.f dget38.f dget39.f dget51.f dget52.f dget53.f 
   dget54.f dglmts.f dgqrts.f dgrqts.f dgsvts.f 
   dhst01.f dlarfy.f dlarhs.f dlatm4.f dlctes.f dlctsx.f dlsets.f dort01.f 
   dort03.f dsbt21.f dsgt01.f dslect.f dspt21.f dstt21.f 
   dstt22.f dsyt21.f dsyt22.f)

set(ZEIGTST  zchkee.f 
   zbdt01.f zbdt02.f zbdt03.f 
   zchkbb.f zchkbd.f zchkbk.f zchkbl.f zchkec.f 
   zchkgg.f zchkgk.f zchkgl.f zchkhb.f zchkhs.f zchkst.f 
   zckcsd.f zckglm.f zckgqr.f zckgsv.f zcklse.f zcsdts.f
   zdrges.f zdrgev.f zdrgsx.f zdrgvx.f 
   zdrvbd.f zdrves.f zdrvev.f zdrvgg.f zdrvsg.f 
   zdrvst.f zdrvsx.f zdrvvx.f 
   zerrbd.f zerrec.f zerred.f zerrgg.f zerrhs.f zerrst.f 
   zget02.f zget10.f zget22.f zget23.f zget24.f 
   zget35.f zget36.f zget37.f zget38.f zget51.f zget52.f 
   zget54.f zglmts.f zgqrts.f zgrqts.f zgsvts.f 
   zhbt21.f zhet21.f zhet22.f zhpt21.f zhst01.f 
   zlarfy.f zlarhs.f zlatm4.f zlctes.f zlctsx.f zlsets.f zsbmv.f 
   zsgt01.f zslect.f 
   zstt21.f zstt22.f zunt01.f zunt03.f)

macro(add_eig_executable name )
  add_executable(${name} ${ARGN})
  target_link_libraries(${name} tmglib lapack )
endmacro(add_eig_executable)

if (BUILD_SINGLE)
add_eig_executable(xeigtsts ${SEIGTST} ${SCIGTST} ${AEIGTST} 
  ${SECOND_SRC} )
endif()

if (BUILD_COMPLEX)
add_eig_executable(xeigtstc ${CEIGTST} ${SCIGTST} ${AEIGTST}
  ${SECOND_SRC} )
endif()

if (BUILD_DOUBLE)
add_eig_executable(xeigtstd ${DEIGTST} ${DZIGTST} ${AEIGTST} 
  ${DSECOND_SRC} )
endif()

if (BUILD_COMPLEX16)
add_eig_executable(xeigtstz ${ZEIGTST} ${DZIGTST} ${AEIGTST}
  ${DSECOND_SRC} )
endif()

=== LIN/CMakeLists.txt ===
set(ALINTST  
   aladhd.f alaerh.f alaesm.f alahd.f alareq.f 
   alasum.f alasvm.f chkxer.f icopy.f ilaenv.f xlaenv.f xerbla.f)

set(SCLNTST slaord.f)

set(DZLNTST dlaord.f )

set(SLINTST  schkaa.f 
   schkeq.f schkgb.f schkge.f schkgt.f 
   schklq.f schkpb.f schkpo.f schkps.f schkpp.f 
   schkpt.f schkq3.f schkql.f schkqp.f schkqr.f schkrq.f 
   schksp.f schksy.f schktb.f schktp.f schktr.f 
   schktz.f 
   sdrvgt.f sdrvls.f sdrvpb.f 
   sdrvpp.f sdrvpt.f sdrvsp.f sdrvsy.f 
   serrgt.f serrlq.f serrls.f 
   serrpo.f serrps.f serrql.f serrqp.f serrqr.f 
   serrrq.f serrsy.f serrtr.f serrtz.f serrvx.f 
   sgbt01.f sgbt02.f sgbt05.f sgelqs.f sgeqls.f sgeqrs.f 
   sgerqs.f sget01.f sget02.f 
   sget03.f sget04.f sget06.f sget07.f sgtt01.f sgtt02.f 
   sgtt05.f slaptm.f slarhs.f slatb4.f slatb5.f slattb.f slattp.f 
   slattr.f slavsp.f slavsy.f slqt01.f slqt02.f 
   slqt03.f spbt01.f spbt02.f spbt05.f spot01.f 
   spot02.f spot03.f spot05.f spst01.f sppt01.f 
   sppt02.f sppt03.f sppt05.f sptt01.f sptt02.f 
   sptt05.f sqlt01.f sqlt02.f sqlt03.f sqpt01.f 
   sqrt01.f sqrt01p.f sqrt02.f sqrt03.f sqrt11.f sqrt12.f 
   sqrt13.f sqrt14.f sqrt15.f sqrt16.f sqrt17.f 
   srqt01.f srqt02.f srqt03.f srzt01.f srzt02.f 
   sspt01.f ssyt01.f 
   stbt02.f stbt03.f stbt05.f stbt06.f stpt01.f 
   stpt02.f stpt03.f stpt05.f stpt06.f strt01.f 
   strt02.f strt03.f strt05.f strt06.f 
   stzt01.f stzt02.f sgennd.f)

if(USEXBLAS)
  list(APPEND SLINTST sdrvgex.f serrgex.f sdrvgbx.f sdrvpox.f sebchvxx.f)
else()
  list(APPEND SLINTST sdrvge.f serrge.f sdrvgb.f sdrvpo.f)
endif()

set(CLINTST  cchkaa.f 
   cchkeq.f cchkgb.f cchkge.f cchkgt.f 
   cchkhe.f cchkhp.f cchklq.f cchkpb.f 
   cchkpo.f cchkps.f cchkpp.f cchkpt.f cchkq3.f cchkql.f cchkqp.f 
   cchkqr.f cchkrq.f cchksp.f cchksy.f cchktb.f 
   cchktp.f cchktr.f cchktz.f 
   cdrvgt.f cdrvhe.f cdrvhp.f 
   cdrvls.f cdrvpb.f cdrvpp.f cdrvpt.f 
   cdrvsp.f cdrvsy.f 
   cerrgt.f cerrhe.f cerrlq.f 
   cerrls.f cerrps.f cerrql.f cerrqp.f 
   cerrqr.f cerrrq.f cerrsy.f cerrtr.f cerrtz.f 
   cerrvx.f 
   cgbt01.f cgbt02.f cgbt05.f cgelqs.f cgeqls.f cgeqrs.f 
   cgerqs.f cget01.f cget02.f 
   cget03.f cget04.f cget07.f cgtt01.f cgtt02.f 
   cgtt05.f chet01.f chpt01.f claipd.f claptm.f clarhs.f clatb4.f clatb5.f 
   clatsp.f clatsy.f clattb.f clattp.f clattr.f 
   clavhe.f clavhp.f clavsp.f clavsy.f clqt01.f 
   clqt02.f clqt03.f cpbt01.f cpbt02.f cpbt05.f 
   cpot01.f cpot02.f cpot03.f cpot05.f cpst01.f 
   cppt01.f cppt02.f cppt03.f cppt05.f cptt01.f 
   cptt02.f cptt05.f cqlt01.f cqlt02.f cqlt03.f 
   cqpt01.f cqrt01.f cqrt01p.f cqrt02.f cqrt03.f cqrt11.f 
   cqrt12.f cqrt13.f cqrt14.f cqrt15.f cqrt16.f 
   cqrt17.f crqt01.f crqt02.f crqt03.f crzt01.f crzt02.f 
   csbmv.f  cspt01.f 
   cspt02.f cspt03.f csyt01.f csyt02.f csyt03.f 
   ctbt02.f ctbt03.f ctbt05.f ctbt06.f ctpt01.f 
   ctpt02.f ctpt03.f ctpt05.f ctpt06.f ctrt01.f 
   ctrt02.f ctrt03.f ctrt05.f ctrt06.f 
   ctzt01.f ctzt02.f sget06.f cgennd.f)

if(USEXBLAS)
  list(APPEND 
    CLINTST cdrvgex.f cdrvgbx.f cerrgex.f cdrvpox.f cerrpox.f cebchvxx.f)
else()
  list(APPEND CLINTST cdrvge.f cdrvgb.f cerrge.f cdrvpo.f cerrpo.f)
endif()

set(DLINTST  dchkaa.f 
   dchkeq.f dchkgb.f dchkge.f dchkgt.f 
   dchklq.f dchkpb.f dchkpo.f dchkps.f dchkpp.f 
   dchkpt.f dchkq3.f dchkql.f dchkqp.f dchkqr.f dchkrq.f 
   dchksp.f dchksy.f dchktb.f dchktp.f dchktr.f 
   dchktz.f 
   ddrvgt.f ddrvls.f ddrvpb.f 
   ddrvpp.f ddrvpt.f ddrvsp.f ddrvsy.f 
   derrgt.f derrlq.f derrls.f 
   derrps.f derrql.f derrqp.f derrqr.f 
   derrrq.f derrsy.f derrtr.f derrtz.f derrvx.f 
   dgbt01.f dgbt02.f dgbt05.f dgelqs.f dgeqls.f dgeqrs.f 
   dgerqs.f dget01.f dget02.f 
   dget03.f dget04.f dget06.f dget07.f dgtt01.f dgtt02.f 
   dgtt05.f dlaptm.f dlarhs.f dlatb4.f dlatb5.f dlattb.f dlattp.f 
   dlattr.f dlavsp.f dlavsy.f dlqt01.f dlqt02.f 
   dlqt03.f dpbt01.f dpbt02.f dpbt05.f dpot01.f 
   dpot02.f dpot03.f dpot05.f dpst01.f dppt01.f 
   dppt02.f dppt03.f dppt05.f dptt01.f dptt02.f 
   dptt05.f dqlt01.f dqlt02.f dqlt03.f dqpt01.f 
   dqrt01.f dqrt01p.f dqrt02.f dqrt03.f dqrt11.f dqrt12.f 
   dqrt13.f dqrt14.f dqrt15.f dqrt16.f dqrt17.f 
   drqt01.f drqt02.f drqt03.f drzt01.f drzt02.f 
   dspt01.f dsyt01.f 
   dtbt02.f dtbt03.f dtbt05.f dtbt06.f dtpt01.f 
   dtpt02.f dtpt03.f dtpt05.f dtpt06.f dtrt01.f 
   dtrt02.f dtrt03.f dtrt05.f dtrt06.f 
   dtzt01.f dtzt02.f dgennd.f)

if(USEXBLAS)
  list(APPEND 
    DLINTST  ddrvgex.f ddrvgbx.f derrgex.f ddrvpox.f derrpox.f debchvxx.f)
else()
  list(APPEND
    DLINTST  ddrvge.f ddrvgb.f derrge.f ddrvpo.f derrpo.f)
endif()

set(ZLINTST  zchkaa.f 
   zchkeq.f zchkgb.f zchkge.f zchkgt.f 
   zchkhe.f zchkhp.f zchklq.f zchkpb.f 
   zchkpo.f zchkps.f zchkpp.f zchkpt.f zchkq3.f zchkql.f zchkqp.f 
   zchkqr.f zchkrq.f zchksp.f zchksy.f zchktb.f 
   zchktp.f zchktr.f zchktz.f 
   zdrvgt.f zdrvhe.f zdrvhp.f 
   zdrvls.f zdrvpb.f zdrvpp.f zdrvpt.f 
   zdrvsp.f zdrvsy.f 
   zerrgt.f zerrhe.f zerrlq.f 
   zerrls.f zerrps.f zerrql.f zerrqp.f 
   zerrqr.f zerrrq.f zerrsy.f zerrtr.f zerrtz.f 
   zerrvx.f 
   zgbt01.f zgbt02.f zgbt05.f zgelqs.f zgeqls.f zgeqrs.f 
   zgerqs.f zget01.f zget02.f 
   zget03.f zget04.f zget07.f zgtt01.f zgtt02.f 
   zgtt05.f zhet01.f zhpt01.f zlaipd.f zlaptm.f zlarhs.f zlatb4.f zlatb5.f 
   zlatsp.f zlatsy.f zlattb.f zlattp.f zlattr.f 
   zlavhe.f zlavhp.f zlavsp.f zlavsy.f zlqt01.f 
   zlqt02.f zlqt03.f zpbt01.f zpbt02.f zpbt05.f 
   zpot01.f zpot02.f zpot03.f zpot05.f zpst01.f 
   zppt01.f zppt02.f zppt03.f zppt05.f zptt01.f 
   zptt02.f zptt05.f zqlt01.f zqlt02.f zqlt03.f 
   zqpt01.f zqrt01.f zqrt01p.f zqrt02.f zqrt03.f zqrt11.f 
   zqrt12.f zqrt13.f zqrt14.f zqrt15.f zqrt16.f 
   zqrt17.f zrqt01.f zrqt02.f zrqt03.f zrzt01.f zrzt02.f 
   zsbmv.f  zspt01.f 
   zspt02.f zspt03.f zsyt01.f zsyt02.f zsyt03.f 
   ztbt02.f ztbt03.f ztbt05.f ztbt06.f ztpt01.f 
   ztpt02.f ztpt03.f ztpt05.f ztpt06.f ztrt01.f 
   ztrt02.f ztrt03.f ztrt05.f ztrt06.f 
   ztzt01.f ztzt02.f dget06.f zgennd.f)

if(USEXBLAS)
  list(APPEND
    ZLINTST  zdrvgex.f zdrvgbx.f zerrgex.f zdrvpox.f zerrpox.f zebchvxx.f)
else()
  list(APPEND
    ZLINTST  zdrvge.f zdrvgb.f zerrge.f zdrvpo.f zerrpo.f)
endif()

set(DSLINTST  dchkab.f 
	ddrvab.f ddrvac.f derrab.f derrac.f dget08.f          
	alaerh.f alahd.f  aladhd.f alareq.f 
	chkxer.f dlarhs.f dlatb4.f xerbla.f 
	dget02.f dpot06.f)

set(ZCLINTST  zchkab.f 
	zdrvab.f zdrvac.f zerrab.f zerrac.f zget08.f          
	alaerh.f alahd.f  aladhd.f alareq.f 
	chkxer.f zget02.f zlarhs.f zlatb4.f 
	zsbmv.f  xerbla.f zpot06.f zlaipd.f)

set(SLINTSTRFP  schkrfp.f sdrvrfp.f sdrvrf1.f sdrvrf2.f sdrvrf3.f sdrvrf4.f serrrfp.f 
	slatb4.f slarhs.f sget04.f spot01.f spot03.f spot02.f 
	chkxer.f xerbla.f alaerh.f aladhd.f alahd.f alasvm.f )

set(DLINTSTRFP  dchkrfp.f ddrvrfp.f ddrvrf1.f ddrvrf2.f ddrvrf3.f ddrvrf4.f derrrfp.f 
	dlatb4.f dlarhs.f dget04.f dpot01.f dpot03.f dpot02.f 
	chkxer.f xerbla.f alaerh.f aladhd.f alahd.f alasvm.f )

set(CLINTSTRFP  cchkrfp.f cdrvrfp.f cdrvrf1.f cdrvrf2.f cdrvrf3.f cdrvrf4.f cerrrfp.f 
  claipd.f clatb4.f clarhs.f csbmv.f cget04.f cpot01.f cpot03.f cpot02.f 
  chkxer.f xerbla.f alaerh.f aladhd.f alahd.f alasvm.f )

set(ZLINTSTRFP  zchkrfp.f zdrvrfp.f zdrvrf1.f zdrvrf2.f zdrvrf3.f zdrvrf4.f zerrrfp.f 
  zlatb4.f zlaipd.f zlarhs.f zsbmv.f zget04.f zpot01.f zpot03.f zpot02.f 
  chkxer.f xerbla.f alaerh.f aladhd.f alahd.f alasvm.f )

macro(add_lin_executable name )
  add_executable(${name} ${ARGN})
  target_link_libraries(${name} tmglib lapack)
endmacro(add_lin_executable)

IF(BUILD_SINGLE)
add_lin_executable(xlintsts ${ALINTST} ${SCLNTST} ${SLINTST} ${SECOND_SRC} )
add_lin_executable(xlintstrfs ${SLINTSTRFP} ${SECOND_SRC})
endif()

if(BUILD_DOUBLE)
add_lin_executable(xlintstd  ${ALINTST} ${DLINTST} ${DZLNTST} ${DSECOND_SRC})
add_lin_executable(xlintstrfd ${DLINTSTRFP} ${DSECOND_SRC})
endif()

IF(BUILD_SINGLE AND BUILD_DOUBLE)
add_lin_executable(xlintstds ${DSLINTST} ${SECOND_SRC} ${DSECOND_SRC} )
endif()

if(BUILD_COMPLEX)
add_lin_executable(xlintstc  ${ALINTST} ${CLINTST} ${SCLNTST} ${SECOND_SRC} )
add_lin_executable(xlintstrfc  ${CLINTSTRFP} ${SECOND_SRC})
endif()

if(BUILD_COMPLEX16)
add_lin_executable(xlintstz  ${ALINTST} ${ZLINTST} ${DZLNTST} ${DSECOND_SRC})
add_lin_executable(xlintstrfz ${ZLINTSTRFP} ${DSECOND_SRC})
endif()

IF(BUILD_COMPLEX AND BUILD_COMPLEX16)
add_lin_executable(xlintstzc ${ZCLINTST} ${SECOND_SRC} ${DSECOND_SRC} )
endif()

=== LIN/Makefile ===
include ../../Make.inc
TMGLIB = $(LIBdir)/lapack_matgen.a
FORTRAN = $(F77)
OPTS = $(F77FLAGS)
DRVOPTS = $(OPTS)
NOOPTS = $(F77FLAGS) $(F77NOOPT)
LAPACKLIB = $(LAPACKlib)
#LAPACKLIB = $(FLAPACKlib)
BLASLIB = $(F77BLASlib) $(CBLASlib) $(ATLASlib)
#BLASLIB = $(PTF77BLASlib) $(PTCBLASlib) $(ATLASlib)
#BLASLIB = $(FBLASlib)
LOADER = $(FLINKER)
LOADOPTS = $(FLINKFLAGS)



#######################################################################
#  This makefile creates the test programs for the linear equation
#  routines in LAPACK.  The test files are grouped as follows:
#
#       ALINTST -- Auxiliary test routines
#       SLINTST -- Single precision real test routines
#       CLINTST -- Single precision complex test routines
#       SCLNTST -- Single and Complex routines in common
#       DLINTST -- Double precision real test routines
#       ZLINTST -- Double precision complex test routines
#       DZLNTST -- Double and Double Complex routines in common
#
#  Test programs can be generated for all or some of the four different
#  precisions.  Enter make followed by one or more of the data types
#  desired.  Some examples:
#       make single
#       make single complex
#       make single double complex complex16
#  Alternatively, the command
#       make
#  without any arguments creates all four test programs.
#  The executable files are called
#       xlintims, xlintimd, xlintimc, and xlintimz
#  and are created in the next higher directory level.
#
#  To remove the object files after the executable files have been
#  created, enter
#       make clean
#  On some systems, you can force the source files to be recompiled by
#  entering (for example)
#       make single FRC=FRC
#
#######################################################################

ALINTST = \
   aladhd.o alaerh.o alaesm.o alahd.o alareq.o \
   alasum.o alasvm.o chkxer.o icopy.o ilaenv.o xlaenv.o xerbla.o

SCLNTST= slaord.o

DZLNTST= dlaord.o 

SLINTST = schkaa.o \
   schkeq.o schkgb.o schkge.o schkgt.o \
   schklq.o schkpb.o schkpo.o schkps.o schkpp.o \
   schkpt.o schkq3.o schkql.o schkqp.o schkqr.o schkrq.o \
   schksp.o schksy.o schktb.o schktp.o schktr.o \
   schktz.o \
   sdrvgt.o sdrvls.o sdrvpb.o \
   sdrvpp.o sdrvpt.o sdrvsp.o \
   serrgt.o serrlq.o serrls.o \
   serrps.o serrql.o serrqp.o serrqr.o \
   serrrq.o serrtr.o serrtz.o \
   sgbt01.o sgbt02.o sgbt05.o sgelqs.o sgeqls.o sgeqrs.o \
   sgerqs.o sget01.o sget02.o \
   sget03.o sget04.o sget06.o sget07.o sgtt01.o sgtt02.o \
   sgtt05.o slaptm.o slarhs.o slatb4.o slatb5.o slattb.o slattp.o \
   slattr.o slavsp.o slavsy.o slqt01.o slqt02.o \
   slqt03.o spbt01.o spbt02.o spbt05.o spot01.o \
   spot02.o spot03.o spot05.o spst01.o sppt01.o \
   sppt02.o sppt03.o sppt05.o sptt01.o sptt02.o \
   sptt05.o sqlt01.o sqlt02.o sqlt03.o sqpt01.o \
   sqrt01.o sqrt01p.o sqrt02.o sqrt03.o sqrt11.o sqrt12.o \
   sqrt13.o sqrt14.o sqrt15.o sqrt16.o sqrt17.o \
   srqt01.o srqt02.o srqt03.o srzt01.o srzt02.o \
   sspt01.o ssyt01.o \
   stbt02.o stbt03.o stbt05.o stbt06.o stpt01.o \
   stpt02.o stpt03.o stpt05.o stpt06.o strt01.o \
   strt02.o strt03.o strt05.o strt06.o \
   stzt01.o stzt02.o sgennd.o

ifdef USEXBLAS
SLINTST += serrvxx.o sdrvgex.o sdrvsyx.o serrgex.o sdrvgbx.o sdrvpox.o \
	sebchvxx.o serrsyx.o serrpox.o
else
SLINTST += serrvx.o sdrvge.o sdrvsy.o serrge.o sdrvgb.o sdrvpo.o \
	serrsy.o serrpo.o
endif

CLINTST = cchkaa.o \
   cchkeq.o cchkgb.o cchkge.o cchkgt.o \
   cchkhe.o cchkhp.o cchklq.o cchkpb.o \
   cchkpo.o cchkps.o cchkpp.o cchkpt.o cchkq3.o cchkql.o cchkqp.o \
   cchkqr.o cchkrq.o cchksp.o cchksy.o cchktb.o \
   cchktp.o cchktr.o cchktz.o \
   cdrvgt.o cdrvhp.o \
   cdrvls.o cdrvpb.o cdrvpp.o cdrvpt.o \
   cdrvsp.o \
   cerrgt.o cerrlq.o \
   cerrls.o cerrps.o cerrql.o cerrqp.o \
   cerrqr.o cerrrq.o cerrtr.o cerrtz.o \
   cgbt01.o cgbt02.o cgbt05.o cgelqs.o cgeqls.o cgeqrs.o \
   cgerqs.o cget01.o cget02.o \
   cget03.o cget04.o cget07.o cgtt01.o cgtt02.o \
   cgtt05.o chet01.o chpt01.o claipd.o claptm.o clarhs.o clatb4.o clatb5.o \
   clatsp.o clatsy.o clattb.o clattp.o clattr.o \
   clavhe.o clavhp.o clavsp.o clavsy.o clqt01.o \
   clqt02.o clqt03.o cpbt01.o cpbt02.o cpbt05.o \
   cpot01.o cpot02.o cpot03.o cpot05.o cpst01.o \
   cppt01.o cppt02.o cppt03.o cppt05.o cptt01.o \
   cptt02.o cptt05.o cqlt01.o cqlt02.o cqlt03.o \
   cqpt01.o cqrt01.o cqrt01p.o cqrt02.o cqrt03.o cqrt11.o \
   cqrt12.o cqrt13.o cqrt14.o cqrt15.o cqrt16.o \
   cqrt17.o crqt01.o crqt02.o crqt03.o crzt01.o crzt02.o \
   csbmv.o  cspt01.o \
   cspt02.o cspt03.o csyt01.o csyt02.o csyt03.o \
   ctbt02.o ctbt03.o ctbt05.o ctbt06.o ctpt01.o \
   ctpt02.o ctpt03.o ctpt05.o ctpt06.o ctrt01.o \
   ctrt02.o ctrt03.o ctrt05.o ctrt06.o \
   ctzt01.o ctzt02.o sget06.o cgennd.o

ifdef USEXBLAS
CLINTST += cerrvxx.o cdrvgex.o cdrvsyx.o cdrvgbx.o cerrgex.o cdrvpox.o cdrvhex.o \
	cerrpox.o cebchvxx.o cerrsyx.o cerrhex.o
else
CLINTST += cerrvx.o cdrvge.o cdrvsy.o cdrvgb.o cerrge.o cdrvpo.o cdrvhe.o \
	cerrpo.o cerrsy.o cerrhe.o
endif

DLINTST = dchkaa.o \
   dchkeq.o dchkgb.o dchkge.o dchkgt.o \
   dchklq.o dchkpb.o dchkpo.o dchkps.o dchkpp.o \
   dchkpt.o dchkq3.o dchkql.o dchkqp.o dchkqr.o dchkrq.o \
   dchksp.o dchksy.o dchktb.o dchktp.o dchktr.o \
   dchktz.o \
   ddrvgt.o ddrvls.o ddrvpb.o \
   ddrvpp.o ddrvpt.o ddrvsp.o \
   derrgt.o derrlq.o derrls.o \
   derrps.o derrql.o derrqp.o derrqr.o \
   derrrq.o derrtr.o derrtz.o \
   dgbt01.o dgbt02.o dgbt05.o dgelqs.o dgeqls.o dgeqrs.o \
   dgerqs.o dget01.o dget02.o \
   dget03.o dget04.o dget06.o dget07.o dgtt01.o dgtt02.o \
   dgtt05.o dlaptm.o dlarhs.o dlatb4.o dlatb5.o dlattb.o dlattp.o \
   dlattr.o dlavsp.o dlavsy.o dlqt01.o dlqt02.o \
   dlqt03.o dpbt01.o dpbt02.o dpbt05.o dpot01.o \
   dpot02.o dpot03.o dpot05.o dpst01.o dppt01.o \
   dppt02.o dppt03.o dppt05.o dptt01.o dptt02.o \
   dptt05.o dqlt01.o dqlt02.o dqlt03.o dqpt01.o \
   dqrt01.o dqrt01p.o  dqrt02.o dqrt03.o dqrt11.o dqrt12.o \
   dqrt13.o dqrt14.o dqrt15.o dqrt16.o dqrt17.o \
   drqt01.o drqt02.o drqt03.o drzt01.o drzt02.o \
   dspt01.o dsyt01.o \
   dtbt02.o dtbt03.o dtbt05.o dtbt06.o dtpt01.o \
   dtpt02.o dtpt03.o dtpt05.o dtpt06.o dtrt01.o \
   dtrt02.o dtrt03.o dtrt05.o dtrt06.o \
   dtzt01.o dtzt02.o dgennd.o

ifdef USEXBLAS
DLINTST += derrvxx.o ddrvgex.o ddrvsyx.o ddrvgbx.o derrgex.o ddrvpox.o derrpox.o \
	debchvxx.o derrsyx.o
else
DLINTST += derrvx.o ddrvge.o ddrvsy.o ddrvgb.o derrge.o ddrvpo.o derrpo.o \
	derrsy.o
endif

ZLINTST = zchkaa.o \
   zchkeq.o zchkgb.o zchkge.o zchkgt.o \
   zchkhe.o zchkhp.o zchklq.o zchkpb.o \
   zchkpo.o zchkps.o zchkpp.o zchkpt.o zchkq3.o zchkql.o zchkqp.o \
   zchkqr.o zchkrq.o zchksp.o zchksy.o zchktb.o \
   zchktp.o zchktr.o zchktz.o \
   zdrvgt.o zdrvhp.o \
   zdrvls.o zdrvpb.o zdrvpp.o zdrvpt.o \
   zdrvsp.o \
   zerrgt.o zerrlq.o \
   zerrls.o zerrps.o zerrql.o zerrqp.o \
   zerrqr.o zerrrq.o zerrtr.o zerrtz.o \
   zgbt01.o zgbt02.o zgbt05.o zgelqs.o zgeqls.o zgeqrs.o \
   zgerqs.o zget01.o zget02.o \
   zget03.o zget04.o zget07.o zgtt01.o zgtt02.o \
   zgtt05.o zhet01.o zhpt01.o zlaipd.o zlaptm.o zlarhs.o zlatb4.o zlatb5.o \
   zlatsp.o zlatsy.o zlattb.o zlattp.o zlattr.o \
   zlavhe.o zlavhp.o zlavsp.o zlavsy.o zlqt01.o \
   zlqt02.o zlqt03.o zpbt01.o zpbt02.o zpbt05.o \
   zpot01.o zpot02.o zpot03.o zpot05.o zpst01.o \
   zppt01.o zppt02.o zppt03.o zppt05.o zptt01.o \
   zptt02.o zptt05.o zqlt01.o zqlt02.o zqlt03.o \
   zqpt01.o zqrt01.o zqrt01p.o zqrt02.o zqrt03.o zqrt11.o \
   zqrt12.o zqrt13.o zqrt14.o zqrt15.o zqrt16.o \
   zqrt17.o zrqt01.o zrqt02.o zrqt03.o zrzt01.o zrzt02.o \
   zsbmv.o  zspt01.o \
   zspt02.o zspt03.o zsyt01.o zsyt02.o zsyt03.o \
   ztbt02.o ztbt03.o ztbt05.o ztbt06.o ztpt01.o \
   ztpt02.o ztpt03.o ztpt05.o ztpt06.o ztrt01.o \
   ztrt02.o ztrt03.o ztrt05.o ztrt06.o \
   ztzt01.o ztzt02.o dget06.o zgennd.o

ifdef USEXBLAS
ZLINTST += zerrvxx.o zdrvgex.o zdrvsyx.o zdrvgbx.o zerrgex.o zdrvpox.o zdrvhex.o \
	zerrpox.o zebchvxx.o zerrsyx.o zerrhex.o
else
ZLINTST += zerrvx.o zdrvge.o zdrvsy.o zdrvgb.o zerrge.o zdrvpo.o zdrvhe.o \
	zerrpo.o zerrsy.o zerrhe.o
endif

DSLINTST = dchkab.o \
	ddrvab.o ddrvac.o derrab.o derrac.o dget08.o          \
	alaerh.o alahd.o  aladhd.o alareq.o \
	chkxer.o dlarhs.o dlatb4.o xerbla.o \
	dget02.o dpot06.o

ZCLINTST = zchkab.o \
	zdrvab.o zdrvac.o zerrab.o zerrac.o zget08.o          \
	alaerh.o alahd.o  aladhd.o alareq.o \
	chkxer.o zget02.o zlarhs.o zlatb4.o \
	zsbmv.o  xerbla.o zpot06.o zlaipd.o

SLINTSTRFP = schkrfp.o sdrvrfp.o sdrvrf1.o sdrvrf2.o sdrvrf3.o sdrvrf4.o serrrfp.o \
	slatb4.o slarhs.o sget04.o spot01.o spot03.o spot02.o \
	chkxer.o xerbla.o alaerh.o aladhd.o alahd.o alasvm.o 

DLINTSTRFP = dchkrfp.o ddrvrfp.o ddrvrf1.o ddrvrf2.o ddrvrf3.o ddrvrf4.o derrrfp.o \
	dlatb4.o dlarhs.o dget04.o dpot01.o dpot03.o dpot02.o \
	chkxer.o xerbla.o alaerh.o aladhd.o alahd.o alasvm.o 

CLINTSTRFP = cchkrfp.o cdrvrfp.o cdrvrf1.o cdrvrf2.o cdrvrf3.o cdrvrf4.o cerrrfp.o \
	claipd.o clatb4.o clarhs.o csbmv.o cget04.o cpot01.o cpot03.o cpot02.o \
	chkxer.o xerbla.o alaerh.o aladhd.o alahd.o alasvm.o 

ZLINTSTRFP = zchkrfp.o zdrvrfp.o zdrvrf1.o zdrvrf2.o zdrvrf3.o zdrvrf4.o zerrrfp.o \
	zlatb4.o zlaipd.o zlarhs.o zsbmv.o zget04.o zpot01.o zpot03.o zpot02.o \
	chkxer.o xerbla.o alaerh.o aladhd.o alahd.o alasvm.o 

all:  single double complex complex16 proto-single proto-double proto-complex proto-complex16

single: ../xlintsts
double: ../xlintstd
complex: ../xlintstc
complex16: ../xlintstz 

proto-single: ../xlintstrfs
proto-double: ../xlintstds ../xlintstrfd
proto-complex: ../xlintstrfc
proto-complex16: ../xlintstzc ../xlintstrfz

xlintsts : $(ALINTST) $(SLINTST) $(SCLNTST) $(LAPACKLIB)
	$(LOADER) $(LOADOPTS)  $(ALINTST) $(SCLNTST) $(SLINTST) \
        $(TMGLIB) $(LAPACKLIB) $(XBLASLIB)  $(BLASLIB) -o $@

xlintstc : $(ALINTST) $(CLINTST) $(SCLNTST) $(LAPACKLIB)
	$(LOADER) $(LOADOPTS)  $(ALINTST) $(SCLNTST) $(CLINTST) \
        $(TMGLIB) $(LAPACKLIB) $(XBLASLIB)  $(BLASLIB) -o $@
 
xlintstd : $(ALINTST) $(DLINTST) $(DZLNTST) $(LAPACKLIB)
	$(LOADER) $(LOADOPTS) $^ \
        $(TMGLIB) $(LAPACKLIB) $(XBLASLIB) $(BLASLIB) -o $@
 
xlintstz : $(ALINTST) $(ZLINTST) $(DZLNTST) $(LAPACKLIB)
	$(LOADER) $(LOADOPTS)  $(ALINTST) $(DZLNTST) $(ZLINTST) \
        $(TMGLIB) $(LAPACKLIB) $(XBLASLIB)  $(BLASLIB) -o $@
 
xlintstds : $(DSLINTST) $(LAPACKLIB)
	$(LOADER) $(LOADOPTS)  $(DSLINTST) \
        $(TMGLIB) $(LAPACKLIB) $(BLASLIB) -o $@
 
xlintstzc : $(ZCLINTST) $(LAPACKLIB)
	$(LOADER) $(LOADOPTS)  $(ZCLINTST) \
        $(TMGLIB) $(LAPACKLIB) $(BLASLIB) -o $@
 
xlintstrfs : $(SLINTSTRFP) $(LAPACKLIB)
	$(LOADER) $(LOADOPTS)  $(SLINTSTRFP) \
        $(TMGLIB) $(LAPACKLIB) $(BLASLIB) -o $@
 
xlintstrfd : $(DLINTSTRFP) $(LAPACKLIB)
	$(LOADER) $(LOADOPTS)  $(DLINTSTRFP) \
        $(TMGLIB) $(LAPACKLIB) $(BLASLIB) -o $@
 
xlintstrfc : $(CLINTSTRFP) $(LAPACKLIB)
	$(LOADER) $(LOADOPTS)  $(CLINTSTRFP) \
        $(TMGLIB) $(LAPACKLIB) $(BLASLIB) -o $@
 
xlintstrfz : $(ZLINTSTRFP) $(LAPACKLIB)
	$(LOADER) $(LOADOPTS)  $(ZLINTSTRFP) \
        $(TMGLIB) $(LAPACKLIB) $(BLASLIB) -o $@
 
../xlintsts: xlintsts
	mv xlintsts $@

../xlintstc: xlintstc
	mv xlintstc $@

../xlintstz: xlintstz
	mv xlintstz $@

../xlintstd: xlintstd
	mv xlintstd $@

../xlintstds: xlintstds
	mv xlintstds $@

../xlintstzc: xlintstzc
	mv xlintstzc $@

../xlintstrfs: xlintstrfs
	mv xlintstrfs $@

../xlintstrfc: xlintstrfc
	mv xlintstrfc $@

../xlintstrfd: xlintstrfd
	mv xlintstrfd $@

../xlintstrfz: xlintstrfz
	mv xlintstrfz $@

$(ALINTST): $(FRC)
$(SCLNTST): $(FRC)
$(DZLNTST): $(FRC)
$(SLINTST): $(FRC)
$(CLINTST): $(FRC)
$(DLINTST): $(FRC)
$(ZLINTST): $(FRC)

FRC:
	@FRC=$(FRC)
 
clean:
	rm -f *.o

schkaa.o: schkaa.f
	$(FORTRAN) $(DRVOPTS) -c $< -o $@
dchkaa.o: dchkaa.f
	$(FORTRAN) $(DRVOPTS) -c $< -o $@
cchkaa.o: cchkaa.f
	$(FORTRAN) $(DRVOPTS) -c $< -o $@
zchkaa.o: zchkaa.f
	$(FORTRAN) $(DRVOPTS) -c $< -o $@
 
.f.o: 
	$(FORTRAN) $(OPTS) -c $< -o $@

=== CONFIG/ARCHS/Makefile ===
include ../Make.inc
arch=$(ARCH)
mach=$(ARCH)
dcc=default
cc=gcc
skc=$(skcD)
dkc=$(dkcD)
smc=$(smcD)
dmc=$(dmcD)
comps = skc=$(skc) dkc=$(dkc) smc=$(smc) dmc=$(dmc)

adefd = $(BLDdir)/ARCHS/$(mach)

tarfile : $(mach)
	- rm $(mach).tgz $(mach).tar
	tar cvf $(mach).tar $(mach)
	$(BZIP) $(mach).tar

$(mach)/kern/$(dcc) :
	mkdir $(mach)/kern/$(dcc)
$(mach)/gemm/$(dcc) :
	mkdir $(mach)/gemm/$(dcc)
$(mach)/lapack/$(dcc) :
	mkdir $(mach)/lapack/$(dcc)

res:
	mkdir res
res/goodgcc.txt : res
	echo "'$(GOODGCC)'" > res/goodgcc.txt
$(mach) :
	mkdir $(mach)
	mkdir $(mach)/kern $(mach)/gemm $(mach)/lapack
	$(MAKE) $(mach)/kern/$(skc) dcc=$(skc)
	$(MAKE) $(mach)/kern/$(dkc) dcc=$(dkc)
	$(MAKE) $(mach)/gemm/$(smc) dcc=$(smc)
	$(MAKE) $(mach)/gemm/$(dmc) dcc=$(dmc)
	$(MAKE) $(mach)/lapack/$(dmc) dcc=$(dmc)
	$(MAKE) $(mach)/lapack/$(smc) dcc=$(smc)

xnegr1 : $(SRCdir)/CONFIG/ARCHS/negr1file.c
	$(XCC) $(XCCFLAGS) -o $@ $(SRCdir)/CONFIG/ARCHS/negr1file.c
xnegmm : $(SRCdir)/CONFIG/ARCHS/negmmfile.c
	$(XCC) $(XCCFLAGS) -o $@ $(SRCdir)/CONFIG/ARCHS/negmmfile.c
xnegmv : $(SRCdir)/CONFIG/ARCHS/negmvfile.c
	$(XCC) $(XCCFLAGS) -o $@ $(SRCdir)/CONFIG/ARCHS/negmvfile.c
xnegflt : $(SRCdir)/CONFIG/ARCHS/negflt.c
	$(XCC) -O -o xnegflt $(SRCdir)/CONFIG/ARCHS/negflt.c

ssys_put:
	- cp $(adefd)/kern/sMULADD $(SYSdir)/res/.
	- cp $(adefd)/kern/L1CacheSize $(SYSdir)/res/.
ssys :
	- cp $(SYSdir)/res/sMULADD $(adefd)/kern/.
	./xnegflt $(adefd)/kern/sMULADD
	- cp $(SYSdir)/res/L1CacheSize $(adefd)/kern/.
skern_put:
	- cp $(adefd)/kern/$(skc)/[s,c]TRSM_NB $(BLDdir)/tune/blas/level3/res/.
	- cp $(adefd)/kern/$(skc)/[s,c]MV[N,T]K.sum $(BLDdir)/tune/blas/gemv/res/.
	- cp  $(adefd)/kern/$(skc)/[s,c]R?K.sum $(BLDdir)/tune/blas/ger/res/.
	- cp $(adefd)/kern/$(skc)/[s,c]*_SUMM $(L1Tdir)/res/.
skern: xnegflt xnegr1 xnegmv
	rm -f $(adefd)/kern/$(skc)/[s,c]*
	- cp $(BLDdir)/tune/blas/level3/res/[s,c]TRSM_NB $(adefd)/kern/$(skc)/.
	- cp $(BLDdir)/tune/blas/gemv/res/[s,c]MV[N,T]K.sum $(adefd)/kern/$(skc)/.
	- cp $(BLDdir)/tune/blas/ger/res/[s,c]R?K.sum $(adefd)/kern/$(skc)/.
	./xnegmv  $(adefd)/kern/$(skc)/[s,c]MVNK.sum
	./xnegmv  $(adefd)/kern/$(skc)/[s,c]MVTK.sum
	./xnegr1 $(adefd)/kern/$(skc)/[s,c]R?K.sum
	- cp $(L1Tdir)/res/[s,c]*_SUMM $(adefd)/kern/$(skc)/.
sgemm_put:
	- cp $(adefd)/gemm/$(smc)/[s,c]MMRES.sum $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(smc)/[s,c]gMMRES.sum $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(smc)/[s,c]guMMRES.sum $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(smc)/[s,c]eMMRES.sum $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(smc)/[s,c]MMKSSE.sum $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(smc)/[s,c]Clean[M,N,K] $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(smc)/[s,c]best[N,T][N,T]_* $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(smc)/[s,c]uMMRES $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(smc)/[s,c]uClean[M,N,K] $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(smc)/[s,c]uClean[M,N,K]F $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(smc)/[s,c]nreg $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(smc)/[s,c]fpuMM $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(smc)/[s,c]NCNB $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(smc)/[s,c]Xover.h $(INCAdir)/.
	- cp $(adefd)/gemm/$(smc)/[s,c]Xover.h $(MMTdir)/res/.
sgemm: xnegflt xnegmm
	rm -f $(adefd)/gemm/$(smc)/[s,c]*
	- cp $(MMTdir)/res/[s,c]Clean[M,N,K] $(adefd)/gemm/$(smc)/.
	- cp $(MMTdir)/res/[s,c]best[N,T][N,T]_* $(adefd)/gemm/$(smc)/.
	- cp $(MMTdir)/res/[s,c]uMMRES $(adefd)/gemm/$(smc)/.
	- cp $(MMTdir)/res/[s,c]uClean[M,N,K] $(adefd)/gemm/$(smc)/.
	- cp $(MMTdir)/res/[s,c]uClean[M,N,K]F $(adefd)/gemm/$(smc)/.
	./xnegflt $(adefd)/gemm/$(smc)/*
	- cp $(MMTdir)/res/[s,c]MMRES.sum $(adefd)/gemm/$(smc)/.
	- cp $(MMTdir)/res/[s,c]gMMRES.sum $(adefd)/gemm/$(smc)/.
	- cp $(MMTdir)/res/[s,c]guMMRES.sum $(adefd)/gemm/$(smc)/.
	- cp $(MMTdir)/res/[s,c]eMMRES.sum $(adefd)/gemm/$(smc)/.
	- cp $(MMTdir)/res/[s,c]MMKSSE.sum $(adefd)/gemm/$(smc)/.
	- ./xnegmm $(adefd)/gemm/$(smc)/*MM*.sum
	- cp $(MMTdir)/res/[s,c]nreg $(adefd)/gemm/$(smc)/.
	- cp $(MMTdir)/res/[s,c]fpuMM $(adefd)/gemm/$(smc)/.
	- cp $(MMTdir)/res/[s,c]NCNB $(adefd)/gemm/$(smc)/.
	- cp $(INCAdir)/[s,c]Xover.h $(adefd)/gemm/$(smc)/.
sla_get:
	rm -f $(adefd)/lapack/$(smc)/atlas_[s,c]GetNB_*.h
	for file in $(INCAdir)/atlas_[s,c]GetNB_*.h ; do \
           if [ -s "$${file}" ]; then \
	      cp $${file} $(adefd)/lapack/$(smc)/. ; \
           fi \
        done
	rm -f $(adefd)/lapack/$(smc)/atlas_[s,c]tGetNB_*.h
	for file in $(INCAdir)/atlas_[s,c]tGetNB_*.h ; do \
           if [ -s "$${file}" ]; then \
	      cp $${file} $(adefd)/lapack/$(smc)/. ; \
           fi \
        done
sla_put :
	- cp $(adefd)/lapack/$(smc)/atlas_[s,c]GetNB_*.h $(INCAdir)/.
	- cp $(adefd)/lapack/$(smc)/atlas_[s,c]tGetNB_*.h $(INCAdir)/.
dsys_put:
	- cp $(adefd)/kern/dMULADD $(SYSdir)/res/.
	- cp $(adefd)/kern/L1CacheSize $(SYSdir)/res/.
dsys :
	- cp $(SYSdir)/res/dMULADD $(adefd)/kern/.
	./xnegflt $(adefd)/kern/dMULADD
	- cp $(SYSdir)/res/L1CacheSize $(adefd)/kern/.
dkern_put:
	- cp $(adefd)/kern/$(dkc)/[d,z]TRSM_NB $(BLDdir)/tune/blas/level3/res/.
	- cp $(adefd)/kern/$(dkc)/[d,z]MV[N,T]K.sum $(BLDdir)/tune/blas/gemv/res/.
	- cp  $(adefd)/kern/$(dkc)/[d,z]R?K.sum $(BLDdir)/tune/blas/ger/res/.
	- cp $(adefd)/kern/$(dkc)/[d,z]*_SUMM $(L1Tdir)/res/.
dkern: xnegflt xnegr1 xnegmv
	rm -f $(adefd)/kern/$(dkc)/[d,z]*
	- cp $(BLDdir)/tune/blas/level3/res/[d,z]TRSM_NB $(adefd)/kern/$(dkc)/.
	- cp $(BLDdir)/tune/blas/gemv/res/[d,z]MV[N,T]K.sum $(adefd)/kern/$(dkc)/.
	- cp $(BLDdir)/tune/blas/ger/res/[d,z]R?K.sum $(adefd)/kern/$(dkc)/.
	./xnegmv  $(adefd)/kern/$(dkc)/[d,z]MVNK.sum
	./xnegmv  $(adefd)/kern/$(dkc)/[d,z]MVTK.sum
	./xnegr1 $(adefd)/kern/$(dkc)/[d,z]R?K.sum
	- cp $(L1Tdir)/res/[d,z]*_SUMM $(adefd)/kern/$(dkc)/.
dgemm_put:
	- cp $(adefd)/gemm/$(dmc)/[d,z]MMRES.sum $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(dmc)/[d,z]gMMRES.sum $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(dmc)/[d,z]guMMRES.sum $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(dmc)/[d,z]eMMRES.sum $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(dmc)/[d,z]MMKSSE.sum $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(dmc)/[d,z]Clean[M,N,K] $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(dmc)/[d,z]best[N,T][N,T]_* $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(dmc)/[d,z]uMMRES $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(dmc)/[d,z]uClean[M,N,K] $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(dmc)/[d,z]uClean[M,N,K]F $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(dmc)/[d,z]nreg $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(dmc)/[d,z]fpuMM $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(dmc)/[d,z]NCNB $(MMTdir)/res/.
	- cp $(adefd)/gemm/$(dmc)/[d,z]Xover.h $(INCAdir)/.
	- cp $(adefd)/gemm/$(dmc)/[d,z]Xover.h $(MMTdir)/res/.
dgemm: xnegflt xnegmm
	rm -f $(adefd)/gemm/$(dmc)/[d,z]*
	- cp $(MMTdir)/res/[d,z]Clean[M,N,K] $(adefd)/gemm/$(dmc)/.
	- cp $(MMTdir)/res/[d,z]best[N,T][N,T]_* $(adefd)/gemm/$(dmc)/.
	- cp $(MMTdir)/res/[d,z]uMMRES $(adefd)/gemm/$(dmc)/.
	- cp $(MMTdir)/res/[d,z]uClean[M,N,K] $(adefd)/gemm/$(dmc)/.
	- cp $(MMTdir)/res/[d,z]uClean[M,N,K]F $(adefd)/gemm/$(dmc)/.
	./xnegflt $(adefd)/gemm/$(dmc)/*
	- cp $(MMTdir)/res/[d,z]MMRES.sum $(adefd)/gemm/$(dmc)/.
	- cp $(MMTdir)/res/[d,z]gMMRES.sum $(adefd)/gemm/$(dmc)/.
	- cp $(MMTdir)/res/[d,z]guMMRES.sum $(adefd)/gemm/$(dmc)/.
	- cp $(MMTdir)/res/[d,z]eMMRES.sum $(adefd)/gemm/$(dmc)/.
	- cp $(MMTdir)/res/[d,z]MMKSSE.sum $(adefd)/gemm/$(dmc)/.
	- ./xnegmm $(adefd)/gemm/$(dmc)/*MM*.sum
	- cp $(MMTdir)/res/[d,z]nreg $(adefd)/gemm/$(dmc)/.
	- cp $(MMTdir)/res/[d,z]fpuMM $(adefd)/gemm/$(dmc)/.
	- cp $(MMTdir)/res/[d,z]NCNB $(adefd)/gemm/$(dmc)/.
	- cp $(INCAdir)/[d,z]Xover.h $(adefd)/gemm/$(dmc)/.
dla_get:
	rm -f $(adefd)/lapack/$(dmc)/atlas_[d,z]GetNB_*.h
	for file in $(INCAdir)/atlas_[d,z]GetNB_*.h ; do \
           if [ -s "$${file}" ]; then \
	      cp $${file} $(adefd)/lapack/$(dmc)/. ; \
           fi \
        done
	rm -f $(adefd)/lapack/$(dmc)/atlas_[d,z]tGetNB_*.h
	for file in $(INCAdir)/atlas_[d,z]tGetNB_*.h ; do \
           if [ -s "$${file}" ]; then \
	      cp $${file} $(adefd)/lapack/$(dmc)/. ; \
           fi \
        done
dla_put :
	- cp $(adefd)/lapack/$(dmc)/atlas_[d,z]GetNB_*.h $(INCAdir)/.
	- cp $(adefd)/lapack/$(dmc)/atlas_[d,z]tGetNB_*.h $(INCAdir)/.

la_get : sla_get dla_get
la_put : sla_put dla_put
sys_put : ssys_put dsys_put
kern_put : skern_put dkern_put
gemm_put : sgemm_put dgemm_put
	- cp $(adefd)/gemm/atlas_cacheedge.h $(INCAdir)/.
	- cp $(adefd)/gemm/atlas_cacheedge.h $(MMTdir)/res/.
	- cp $(adefd)/gemm/atlas_tcacheedge.h $(INCAdir)/.
	- cp $(adefd)/gemm/atlas_tcacheedge.h $(MMTdir)/res/.
	- cp $(adefd)/gemm/atlas_??NKB.h $(INCAdir)/.
	- cp $(adefd)/gemm/atlas_??NKB.h $(MMTdir)/res/.
sys : ssys dsys
kern : skern dkern
gemm : sgemm dgemm
	- cp $(INCAdir)/atlas_cacheedge.h $(adefd)/gemm/
	- cp $(INCAdir)/atlas_tcacheedge.h $(adefd)/gemm/
	- cp $(INCAdir)/atlas_??NKB.h $(adefd)/gemm/
ArchNew : $(mach) xnegflt
	$(MAKE) sys kern gemm la_get
	- cp $(BLDdir)/bin/INSTALL_LOG/?PerfSumm.txt $(adefd)/.
	rm -f xnegflt
archput : sys_put kern_put gemm_put la_put

=== CONFIG/src/Makefile ===
SHELL=/bin/sh
SRCdir = $(TOPdir)/CONFIG/src
INCdir = $(TOPdir)/CONFIG/include
mydir = $(BLDdir)
atlrun = atlas_run
INCFLAGS = -I$(INCdir)
MYFLAGS =
CCFLAGS = $(INCFLAGS) $(MYFLAGS) $(CFLAGS)
XCC = $(CC)
XCFLAGS = $(CCFLAGS)
LIBS =
args =
rdir = /tmp
arch=
BUNZIP = bunzip2
TAR = tar
wind=$(BLDdir)

all : build
xconfig : $(SRCdir)/config.c atlconf_misc.o
	$(XCC) $(XCFLAGS) -o xconfig $(SRCdir)/config.c atlconf_misc.o $(LIBS)
xspew : $(SRCdir)/SpewMakeInc.c atlconf_misc.o
	$(XCC) $(XCFLAGS) -o xspew $(SRCdir)/SpewMakeInc.c atlconf_misc.o \
               $(LIBS)
xisgcc : $(SRCdir)/IsGcc.c atlconf_misc.o
	$(XCC) $(XCFLAGS) -o $@ $(SRCdir)/IsGcc.c atlconf_misc.o $(LIBS)
mgwgfortran : $(SRCdir)/mgwcmp.c
	$(XCC) $(XCCFLAGS) "-DDEFDF=$(cmppath)" -o $@ $(SRCdir)/mgwcmp.c
mgwgcc : $(SRCdir)/mgwcmp.c
	$(XCC) $(XCCFLAGS) "-DDEFDF=$(cmppath)" -o $@ $(SRCdir)/mgwcmp.c
mgwar : $(SRCdir)/mgwcmp.c
	$(XCC) $(XCCFLAGS) "-DDEFDF=$(cmppath)" -o $@ $(SRCdir)/mgwcmp.c
mgwranlib : $(SRCdir)/mgwcmp.c
	$(XCC) $(XCCFLAGS) "-DDEFDF=$(cmppath)" -o $@ $(SRCdir)/mgwcmp.c

$(wind)/ATLwin_ifort.exe : $(SRCdir)/winf77.c
	cp $(SRCdir)/wincc.c $(wind)/.
	cd $(wind) ; icl /FeATLwin_ifort.exe /DDEFDF=ifort wincc.c
	rm -f $(wind)/wincc.c
$(wind)/ATLwin_icc.exe : $(SRCdir)/wincc.c
	cp $(SRCdir)/wincc.c $(wind)/.
	cd $(wind) ; icl /FeATLwin_icc.exe /DDEFDF=icl wincc.c
	rm -f $(wind)/wincc.c
$(wind)/ATLwin_cl.exe : $(SRCdir)/wincc.c
	cp $(SRCdir)/wincc.c $(wind)/.
	cd $(wind) ; cl /FeATLwin_cl.exe /DDEFDF=cl wincc.c
	rm -f $(wind)/wincc.c
xprobe_comp : xisgcc probe_comp.o atlconf_misc.o
	$(XCC) $(XCFLAGS) -o xprobe_comp probe_comp.o atlconf_misc.o $(LIBS)
xprobe_aff : probe_aff.o atlconf_misc.o
	$(XCC) $(XCFLAGS) -o xprobe_aff probe_aff.o atlconf_misc.o $(LIBS)
xprobe_pmake : probe_pmake.o atlconf_misc.o
	$(XCC) $(XCFLAGS) -o xprobe_pmake probe_pmake.o atlconf_misc.o $(LIBS)
xprobe_f2c : probe_f2c.o atlconf_misc.o
	$(XCC) $(XCFLAGS) -o xprobe_f2c probe_f2c.o atlconf_misc.o $(LIBS)
xprobe_arch : probe_arch.o atlconf_misc.o
	$(XCC) $(XCFLAGS) -o xprobe_arch probe_arch.o atlconf_misc.o $(LIBS)
xprobe_vec : probe_vec.o atlconf_misc.o
	$(XCC) $(XCFLAGS) -o xprobe_vec probe_vec.o atlconf_misc.o $(LIBS)
xprobe_asm : probe_asm.o atlconf_misc.o
	$(XCC) $(XCFLAGS) -o xprobe_asm probe_asm.o atlconf_misc.o $(LIBS)
xprobe_OS : probe_OS.o atlconf_misc.o
	$(XCC) $(XCFLAGS) -o xprobe_OS probe_OS.o atlconf_misc.o $(LIBS)

xprint_enums : $(SRCdir)/print_enums.c
	$(XCC) $(XCFLAGS) -o xprint_enums $(SRCdir)/print_enums.c
xatlbench : atlbench.o atlconf_misc.o
	$(XCC) $(XCFLAGS) -o xatlbench atlbench.o atlconf_misc.o
probe_aff.o : $(SRCdir)/probe_aff.c
	$(XCC) $(XCFLAGS) -c $(SRCdir)/probe_aff.c
atlbench.o : $(SRCdir)/atlbench.c
	$(XCC) $(XCFLAGS) -c $(SRCdir)/atlbench.c
probe_pmake.o : $(SRCdir)/probe_pmake.c
	$(XCC) $(XCFLAGS) -c $(SRCdir)/probe_pmake.c
probe_f2c.o : $(SRCdir)/probe_f2c.c
	$(XCC) $(XCFLAGS) -c $(SRCdir)/probe_f2c.c
probe_comp.o : $(SRCdir)/probe_comp.c
	$(XCC) $(XCFLAGS) -c $(SRCdir)/probe_comp.c
probe_arch.o : $(SRCdir)/probe_arch.c
	$(XCC) $(XCFLAGS) -c $(SRCdir)/probe_arch.c
probe_vec.o : $(SRCdir)/probe_vec.c
	$(XCC) $(XCFLAGS) -c $(SRCdir)/probe_vec.c
probe_asm.o : $(SRCdir)/probe_asm.c
	$(XCC) $(XCFLAGS) -c $(SRCdir)/probe_asm.c
probe_OS.o : $(SRCdir)/probe_OS.c
	$(XCC) $(XCFLAGS) -c $(SRCdir)/probe_OS.c
atlconf_misc.o : $(SRCdir)/atlconf_misc.c
	$(XCC) $(XCFLAGS) -c $(SRCdir)/atlconf_misc.c
atlconf_misc_BE.o : $(SRCdir)/atlconf_misc.c
	$(CC) $(CCFLAGS) -o atlconf_misc_BE.o -c $(SRCdir)/atlconf_misc.c

atlas_run :
	cd $(atldir) ; ./$(exe) $(args) > $(redir)
atlas_runX :
	scp $(atldir)/$(exe) $(targ):$(rdir)/$(exe)
	ssh $(targ) 'cd $(rdir) ; ./$(exe) $(args)' > $(redir)
force_build:

#
# General probes always ran locally (possibly cross-compiling machine)
# General probes call system (they're essentially shell scripts)
#
IRun_comp: xprobe_comp force_build
	- rm -f config1.out
	$(MAKE) atlas_run atldir=$(mydir) exe=xprobe_comp redir=config1.out \
                args="$(args) -d b $(BLDdir)"
	- cat config1.out
IRun_OS: xprobe_OS force_build
	- rm -f config1.out
	$(MAKE) atlas_run atldir=$(mydir) exe=xprobe_OS args="$(args)" \
                redir=config1.out
	- cat config1.out
IRun_aff: xprobe_aff force_build
	- rm -f config2.out
	$(MAKE) atlas_run atldir=$(mydir) exe=xprobe_aff args="$(args)" \
                redir=config2.out
	- cat config2.out
IRun_pmake: xprobe_pmake force_build
	- rm -f config2.out
	$(MAKE) atlas_run atldir=$(mydir) exe=xprobe_pmake args="$(args)" \
                redir=config2.out
	- cat config2.out
IRun_arch: xprobe_arch force_build
	- rm -f config2.out
	$(MAKE) atlas_run atldir=$(mydir) exe=xprobe_arch args="$(args)" \
                redir=config2.out
	- cat config2.out
IRun_vec: xprobe_vec force_build
	- rm -f config2.out
	$(MAKE) atlas_run atldir=$(mydir) exe=xprobe_vec args="$(args)" \
                redir=config2.out
	- cat config2.out
IRun_asm: xprobe_asm force_build
	- rm -f config2.out
	$(MAKE) atlas_run atldir=$(mydir) exe=xprobe_asm args="$(args)" \
                redir=config2.out
	- cat config2.out
IRun_f2c: xprobe_f2c force_build
	- rm -f config2.out
	$(MAKE) atlas_run atldir=$(mydir) exe=xprobe_f2c args="$(args)" \
                redir=config2.out
	- cat config2.out

#
# Machine-level probes run on machine lib being compiled for
# These probes do not call system, but actually do something
#
IRun_NEON :
	$(CC) $(CCFLAGS) -mfpu=neon -o xprobe_neon \
              $(SRCdir)/backend/probe_svec.c $(SRCdir)/backend/probe_NEON.S
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_neon args="$(args)" \
                redir=config0.out
	- cat config0.out
IRun_3DNow :
	$(CC) $(CCFLAGS) -o xprobe_3dnow $(SRCdir)/backend/probe_svec.c $(SRCdir)/backend/probe_3DNow.S
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_3dnow args="$(args)" \
                redir=config0.out
	- cat config0.out
IRun_VSX :
	$(CC) $(CCFLAGS) -o xprobe_vsx $(SRCdir)/backend/probe_dvec.c $(SRCdir)/backend/probe_VSX.S
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_vsx args="$(args)" \
                redir=config0.out
	- cat config0.out
IRun_AltiVec :
	$(CC) $(CCFLAGS) -o xprobe_altivec $(SRCdir)/backend/probe_svec.c $(SRCdir)/backend/probe_AltiVec.S
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_altivec args="$(args)" \
                redir=config0.out
	- cat config0.out
IRun_SSE2 :
	$(CC) $(CCFLAGS) -o xprobe_sse2 $(SRCdir)/backend/probe_dvec.c $(SRCdir)/backend/probe_SSE2.S
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_sse2 args="$(args)" \
                redir=config0.out
	- cat config0.out
IRun_SSE1 :
	$(CC) $(CCFLAGS) -o xprobe_sse1 $(SRCdir)/backend/probe_svec.c $(SRCdir)/backend/probe_SSE1.S
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_sse1 args="$(args)" \
                redir=config0.out
	- cat config0.out
IRun_SSE3 :
	$(CC) $(CCFLAGS) -o xprobe_sse3 $(SRCdir)/backend/probe_dSSE3.c $(SRCdir)/backend/probe_SSE3.S
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_sse3 args="$(args)" \
                redir=config0.out
	- cat config0.out
IRun_AVXFMA4 :
	$(CC) $(CCFLAGS) -o xprobe_avxmac $(SRCdir)/backend/probe_dAVX.c \
              $(SRCdir)/backend/probe_AVXFMA4.S
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_avxmac args="$(args)" \
                redir=config0.out
	- cat config0.out
IRun_AVXMAC :
	$(CC) $(CCFLAGS) -o xprobe_avxmac $(SRCdir)/backend/probe_dAVX.c \
              $(SRCdir)/backend/probe_AVXMAC.S
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_avxmac args="$(args)" \
                redir=config0.out
	- cat config0.out
IRun_AVX :
	$(CC) $(CCFLAGS) -o xprobe_avx $(SRCdir)/backend/probe_dAVX.c \
              $(SRCdir)/backend/probe_AVX.S
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_avx args="$(args)" \
                redir=config0.out
	- cat config0.out
IRun_WIN64 :
	$(CC) $(CCFLAGS) -o xprobe_WIN64 $(SRCdir)/backend/probe_aff_WIN64.c \
              $(LIBS)
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_WIN64 args="$(args)" \
                redir=config0.out
	- cat config0.out
IRun_WIN :
	$(CC) $(CCFLAGS) -o xprobe_WIN $(SRCdir)/backend/probe_aff_WIN.c \
              $(LIBS)
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_WIN args="$(args)" \
                redir=config0.out
	- cat config0.out
IRun_CPUSET :
	$(CC) $(CCFLAGS) -o xprobe_CPUSET $(SRCdir)/backend/probe_aff_CPUSET.c \
              $(LIBS)
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_CPUSET args="$(args)" \
                redir=config0.out
	- cat config0.out
IRun_SETPROCNP :
	$(CC) $(CCFLAGS) -o xprobe_SETPROCNP $(SRCdir)/backend/probe_aff_SETPROCNP.c \
              $(LIBS)
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_SETPROCNP args="$(args)" \
                redir=config0.out
	- cat config0.out
IRun_SETAFFNP :
	$(CC) $(CCFLAGS) -o xprobe_SETAFFNP $(SRCdir)/backend/probe_aff_SETAFFNP.c \
              $(LIBS)
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_SETAFFNP args="$(args)" \
                redir=config0.out
	- cat config0.out
IRun_SCHED :
	$(CC) $(CCFLAGS) -o xprobe_SCHED $(SRCdir)/backend/probe_aff_SCHED.c \
              $(LIBS)
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_SCHED args="$(args)" \
                redir=config0.out
	- cat config0.out
IRun_RUNON :
	$(CC) $(CCFLAGS) -o xprobe_RUNON $(SRCdir)/backend/probe_aff_RUNON.c \
              $(LIBS)
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_RUNON args="$(args)" \
                redir=config0.out
	- cat config0.out
IRun_PLPA :
	$(CC) $(CCFLAGS) -o xprobe_PLPA $(SRCdir)/backend/probe_aff_PLPA.c \
              $(LIBS)
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_PLPA args="$(args)" \
                redir=config0.out
	- cat config0.out
IRun_PBIND :
	$(CC) $(CCFLAGS) -o xprobe_PBIND $(SRCdir)/backend/probe_aff_PBIND.c \
              $(LIBS)
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_PBIND args="$(args)" \
                redir=config0.out
	- cat config0.out
IRun_BINDP :
	$(CC) $(CCFLAGS) -o xprobe_BINDP $(SRCdir)/backend/probe_aff_BINDP.c \
              $(LIBS)
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_BINDP args="$(args)" \
                redir=config0.out
	- cat config0.out

IRun_GAS_S390 :
	$(CC) $(CCFLAGS) -o xprobe_gas_s390 $(SRCdir)/backend/probe_this_asm.c $(SRCdir)/backend/probe_gas_s390.S
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_gas_s390 args="$(args)" \
                redir=config0.out
	- cat config0.out
IRun_GAS_ARM :
	$(CC) $(CCFLAGS) -o xprobe_gas_arm $(SRCdir)/backend/probe_this_asm.c $(SRCdir)/backend/probe_gas_arm.S
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_gas_arm args="$(args)" \
                redir=config0.out
	- cat config0.out
IRun_GAS_SPARC :
	$(CC) $(CCFLAGS) -o xprobe_gas_sparc $(SRCdir)/backend/probe_this_asm.c $(SRCdir)/backend/probe_gas_sparc.S
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_gas_sparc args="$(args)" \
                redir=config0.out
	- cat config0.out
IRun_GAS_PARISC :
	$(CC) $(CCFLAGS) -o xprobe_gas_parisc $(SRCdir)/backend/probe_this_asm.c $(SRCdir)/backend/probe_gas_parisc.S
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_gas_parisc args="$(args)" \
                redir=config0.out
	- cat config0.out
IRun_GAS_PPC :
	$(CC) $(CCFLAGS) -o xprobe_gas_ppc $(SRCdir)/backend/probe_this_asm.c $(SRCdir)/backend/probe_gas_ppc.S
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_gas_ppc args="$(args)" \
                redir=config0.out
	- cat config0.out
IRun_GAS_x8664 :
	$(CC) $(CCFLAGS) -o xprobe_gas_x8664 $(SRCdir)/backend/probe_this_asm.c $(SRCdir)/backend/probe_gas_x8664.S
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_gas_x8664 args="$(args)" \
                redir=config0.out
	- cat config0.out
IRun_GAS_x8632 :
	$(CC) $(CCFLAGS) -o xprobe_gas_x8632 $(SRCdir)/backend/probe_this_asm.c $(SRCdir)/backend/probe_gas_x8632.S
	$(MAKE) $(atlrun) atldir=$(mydir) exe=xprobe_gas_x8632 args="$(args)" \
                redir=config0.out
	- cat config0.out

IRunC2C :
	- rm -f config0.out xc2c c2cslave.o
	$(CC1) $(CC1FLAGS) -c $(SRCdir)/backend/c2cslave.c

=== tune/blas/gemm/CASES/objs/Makefile ===
all:
	nasm -f elf -DELF -DPREC_DST1 -DPREB_DST1 -o djulian1x1_bX.o \
             ATL_dJIK30x30x30TN30x30x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST2 -DPREB_DST1 -o djulian1x2_bX.o \
             ATL_dJIK30x30x30TN30x30x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST3 -DPREB_DST1 -o djulian1x3_bX.o \
             ATL_dJIK30x30x30TN30x30x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST4 -DPREB_DST1 -o djulian1x4_bX.o \
             ATL_dJIK30x30x30TN30x30x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST1 -DPREB_DST2 -o djulian2x1_bX.o \
             ATL_dJIK30x30x30TN30x30x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST2 -DPREB_DST2 -o djulian2x2_bX.o \
             ATL_dJIK30x30x30TN30x30x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST3 -DPREB_DST2 -o djulian2x3_bX.o \
             ATL_dJIK30x30x30TN30x30x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST4 -DPREB_DST2 -o djulian2x4_bX.o \
             ATL_dJIK30x30x30TN30x30x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST1 -DPREB_DST3 -o djulian3x1_bX.o \
             ATL_dJIK30x30x30TN30x30x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST2 -DPREB_DST3 -o djulian3x2_bX.o \
             ATL_dJIK30x30x30TN30x30x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST3 -DPREB_DST3 -o djulian3x3_bX.o \
             ATL_dJIK30x30x30TN30x30x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST4 -DPREB_DST3 -o djulian3x4_bX.o \
             ATL_dJIK30x30x30TN30x30x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST1 -DPREB_DST4 -o djulian4x1_bX.o \
             ATL_dJIK30x30x30TN30x30x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST2 -DPREB_DST4 -o djulian4x2_bX.o \
             ATL_dJIK30x30x30TN30x30x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST3 -DPREB_DST4 -o djulian4x3_bX.o \
             ATL_dJIK30x30x30TN30x30x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST4 -DPREB_DST4 -o djulian4x4_bX.o \
             ATL_dJIK30x30x30TN30x30x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST1 -DPREB_DST1 -o sjulian1x1_bX.o \
             ATL_sJIK48x48x48TN48x48x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST2 -DPREB_DST1 -o sjulian1x2_bX.o \
             ATL_sJIK48x48x48TN48x48x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST3 -DPREB_DST1 -o sjulian1x3_bX.o \
             ATL_sJIK48x48x48TN48x48x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST4 -DPREB_DST1 -o sjulian1x4_bX.o \
             ATL_sJIK48x48x48TN48x48x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST5 -DPREB_DST1 -o sjulian1x5_bX.o \
             ATL_sJIK48x48x48TN48x48x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST6 -DPREB_DST1 -o sjulian1x6_bX.o \
             ATL_sJIK48x48x48TN48x48x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST7 -DPREB_DST1 -o sjulian1x7_bX.o \
             ATL_sJIK48x48x48TN48x48x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST1 -DPREB_DST2 -o sjulian2x1_bX.o \
             ATL_sJIK48x48x48TN48x48x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST2 -DPREB_DST2 -o sjulian2x2_bX.o \
             ATL_sJIK48x48x48TN48x48x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST3 -DPREB_DST2 -o sjulian2x3_bX.o \
             ATL_sJIK48x48x48TN48x48x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST4 -DPREB_DST2 -o sjulian2x4_bX.o \
             ATL_sJIK48x48x48TN48x48x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST5 -DPREB_DST2 -o sjulian2x5_bX.o \
             ATL_sJIK48x48x48TN48x48x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST6 -DPREB_DST2 -o sjulian2x6_bX.o \
             ATL_sJIK48x48x48TN48x48x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST7 -DPREB_DST2 -o sjulian2x7_bX.o \
             ATL_sJIK48x48x48TN48x48x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST1 -DPREB_DST3 -o sjulian3x1_bX.o \
             ATL_sJIK48x48x48TN48x48x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST2 -DPREB_DST3 -o sjulian3x2_bX.o \
             ATL_sJIK48x48x48TN48x48x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST3 -DPREB_DST3 -o sjulian3x3_bX.o \
             ATL_sJIK48x48x48TN48x48x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST4 -DPREB_DST3 -o sjulian3x4_bX.o \
             ATL_sJIK48x48x48TN48x48x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST5 -DPREB_DST3 -o sjulian3x5_bX.o \
             ATL_sJIK48x48x48TN48x48x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST6 -DPREB_DST3 -o sjulian3x6_bX.o \
             ATL_sJIK48x48x48TN48x48x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST7 -DPREB_DST3 -o sjulian3x7_bX.o \
             ATL_sJIK48x48x48TN48x48x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST1 -DPREB_DST4 -o sjulian4x1_bX.o \
             ATL_sJIK48x48x48TN48x48x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST2 -DPREB_DST4 -o sjulian4x2_bX.o \
             ATL_sJIK48x48x48TN48x48x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST3 -DPREB_DST4 -o sjulian4x3_bX.o \
             ATL_sJIK48x48x48TN48x48x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST4 -DPREB_DST4 -o sjulian4x4_bX.o \
             ATL_sJIK48x48x48TN48x48x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST5 -DPREB_DST4 -o sjulian4x5_bX.o \
             ATL_sJIK48x48x48TN48x48x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST6 -DPREB_DST4 -o sjulian4x6_bX.o \
             ATL_sJIK48x48x48TN48x48x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST7 -DPREB_DST4 -o sjulian4x7_bX.o \
             ATL_sJIK48x48x48TN48x48x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST1 -DPREB_DST5 -o sjulian5x1_bX.o \
             ATL_sJIK48x48x48TN48x48x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST2 -DPREB_DST5 -o sjulian5x2_bX.o \
             ATL_sJIK48x48x48TN48x48x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST3 -DPREB_DST5 -o sjulian5x3_bX.o \
             ATL_sJIK48x48x48TN48x48x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST4 -DPREB_DST5 -o sjulian5x4_bX.o \
             ATL_sJIK48x48x48TN48x48x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST5 -DPREB_DST5 -o sjulian5x5_bX.o \
             ATL_sJIK48x48x48TN48x48x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST6 -DPREB_DST5 -o sjulian5x6_bX.o \
             ATL_sJIK48x48x48TN48x48x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST7 -DPREB_DST5 -o sjulian5x7_bX.o \
             ATL_sJIK48x48x48TN48x48x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST1 -DPREB_DST6 -o sjulian6x1_bX.o \
             ATL_sJIK48x48x48TN48x48x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST2 -DPREB_DST6 -o sjulian6x2_bX.o \
             ATL_sJIK48x48x48TN48x48x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST3 -DPREB_DST6 -o sjulian6x3_bX.o \
             ATL_sJIK48x48x48TN48x48x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST4 -DPREB_DST6 -o sjulian6x4_bX.o \
             ATL_sJIK48x48x48TN48x48x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST5 -DPREB_DST6 -o sjulian6x5_bX.o \
             ATL_sJIK48x48x48TN48x48x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST6 -DPREB_DST6 -o sjulian6x6_bX.o \
             ATL_sJIK48x48x48TN48x48x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST7 -DPREB_DST6 -o sjulian6x7_bX.o \
             ATL_sJIK48x48x48TN48x48x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST1 -DPREB_DST7 -o sjulian7x1_bX.o \
             ATL_sJIK48x48x48TN48x48x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST2 -DPREB_DST7 -o sjulian7x2_bX.o \
             ATL_sJIK48x48x48TN48x48x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST3 -DPREB_DST7 -o sjulian7x3_bX.o \
             ATL_sJIK48x48x48TN48x48x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST4 -DPREB_DST7 -o sjulian7x4_bX.o \
             ATL_sJIK48x48x48TN48x48x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST5 -DPREB_DST7 -o sjulian7x5_bX.o \
             ATL_sJIK48x48x48TN48x48x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST6 -DPREB_DST7 -o sjulian7x6_bX.o \
             ATL_sJIK48x48x48TN48x48x0_a1_bX.asm
	nasm -f elf -DELF -DPREC_DST7 -DPREB_DST7 -o sjulian7x7_bX.o \
             ATL_sJIK48x48x48TN48x48x0_a1_bX.asm

	nasm -f elf -DELF -DPREC_DST1 -DPREB_DST1 -o djulian1x1_b1.o \
             ATL_dJIK30x30x30TN30x30x0_a1_b1.asm
	nasm -f elf -DELF -DPREC_DST2 -DPREB_DST1 -o djulian1x2_b1.o \
             ATL_dJIK30x30x30TN30x30x0_a1_b1.asm
	nasm -f elf -DELF -DPREC_DST3 -DPREB_DST1 -o djulian1x3_b1.o \
             ATL_dJIK30x30x30TN30x30x0_a1_b1.asm
	nasm -f elf -DELF -DPREC_DST4 -DPREB_DST1 -o djulian1x4_b1.o \
             ATL_dJIK30x30x30TN30x30x0_a1_b1.asm
	nasm -f elf -DELF -DPREC_DST1 -DPREB_DST2 -o djulian2x1_b1.o \
             ATL_dJIK30x30x30TN30x30x0_a1_b1.asm
	nasm -f elf -DELF -DPREC_DST2 -DPREB_DST2 -o djulian2x2_b1.o \
             ATL_dJIK30x30x30TN30x30x0_a1_b1.asm
	nasm -f elf -DELF -DPREC_DST3 -DPREB_DST2 -o djulian2x3_b1.o \
             ATL_dJIK30x30x30TN30x30x0_a1_b1.asm
	nasm -f elf -DELF -DPREC_DST4 -DPREB_DST2 -o djulian2x4_b1.o \
             ATL_dJIK30x30x30TN30x30x0_a1_b1.asm
	nasm -f elf -DELF -DPREC_DST1 -DPREB_DST3 -o djulian3x1_b1.o \
             ATL_dJIK30x30x30TN30x30x0_a1_b1.asm
	nasm -f elf -DELF -DPREC_DST2 -DPREB_DST3 -o djulian3x2_b1.o \
             ATL_dJIK30x30x30TN30x30x0_a1_b1.asm
	nasm -f elf -DELF -DPREC_DST3 -DPREB_DST3 -o djulian3x3_b1.o \
             ATL_dJIK30x30x30TN30x30x0_a1_b1.asm
	nasm -f elf -DELF -DPREC_DST4 -DPREB_DST3 -o djulian3x4_b1.o \
             ATL_dJIK30x30x30TN30x30x0_a1_b1.asm
	nasm -f elf -DELF -DPREC_DST1 -DPREB_DST4 -o djulian4x1_b1.o \
             ATL_dJIK30x30x30TN30x30x0_a1_b1.asm
	nasm -f elf -DELF -DPREC_DST2 -DPREB_DST4 -o djulian4x2_b1.o \
             ATL_dJIK30x30x30TN30x30x0_a1_b1.asm
	nasm -f elf -DELF -DPREC_DST3 -DPREB_DST4 -o djulian4x3_b1.o \
             ATL_dJIK30x30x30TN30x30x0_a1_b1.asm
	nasm -f elf -DELF -DPREC_DST4 -DPREB_DST4 -o djulian4x4_b1.o \
             ATL_dJIK30x30x30TN30x30x0_a1_b1.asm
	nasm -f elf -DELF -DPREC_DST1 -DPREB_DST1 -o sjulian1x1_b1.o \
             ATL_sJIK48x48x48TN48x48x0_a1_b1.asm
	nasm -f elf -DELF -DPREC_DST2 -DPREB_DST1 -o sjulian1x2_b1.o \
             ATL_sJIK48x48x48TN48x48x0_a1_b1.asm
	nasm -f elf -DELF -DPREC_DST3 -DPREB_DST1 -o sjulian1x3_b1.o \
             ATL_sJIK48x48x48TN48x48x0_a1_b1.asm
	nasm -f elf -DELF -DPREC_DST4 -DPREB_DST1 -o sjulian1x4_b1.o \
             ATL_sJIK48x48x48TN48x48x0_a1_b1.asm
	nasm -f elf -DELF -DPREC_DST5 -DPREB_DST1 -o sjulian1x5_b1.o \
             ATL_sJIK48x48x48TN48x48x0_a1_b1.asm
	nasm -f elf -DELF -DPREC_DST6 -DPREB_DST1 -o sjulian1x6_b1.o \
             ATL_sJIK48x48x48TN48x48x0_a1_b1.asm
	nasm -f elf -DELF -DPREC_DST7 -DPREB_DST1 -o sjulian1x7_b1.o \
             ATL_sJIK48x48x48TN48x48x0_a1_b1.asm
	nasm -f elf -DELF -DPREC_DST1 -DPREB_DST2 -o sjulian2x1_b1.o \
             ATL_sJIK48x48x48TN48x48x0_a1_b1.asm
	nasm -f elf -DELF -DPREC_DST2 -DPREB_DST2 -o sjulian2x2_b1.o \
             ATL_sJIK48x48x48TN48x48x0_a1_b1.asm
	nasm -f elf -DELF -DPREC_DST3 -DPREB_DST2 -o sjulian2x3_b1.o \
             ATL_sJIK48x48x48TN48x48x0_a1_b1.asm
	nasm -f elf -DELF -DPREC_DST4 -DPREB_DST2 -o sjulian2x4_b1.o \
             ATL_sJIK48x48x48TN48x48x0_a1_b1.asm
	nasm -f elf -DELF -DPREC_DST5 -DPREB_DST2 -o sjulian2x5_b1.o \
             ATL_sJIK48x48x48TN48x48x0_a1_b1.asm
	nasm -f elf -DELF -DPREC_DST6 -DPREB_DST2 -o sjulian2x6_b1.o \
             ATL_sJIK48x48x48TN48x48x0_a1_b1.asm
	nasm -f elf -DELF -DPREC_DST7 -DPREB_DST2 -o sjulian2x7_b1.o \
             ATL_sJIK48x48x48TN48x48x0_a1_b1.asm
	nasm -f elf -DELF -DPREC_DST1 -DPREB_DST3 -o sjulian3x1_b1.o \
             ATL_sJIK48x48x48TN48x48x0_a1_b1.asm
	nasm -f elf -DELF -DPREC_DST2 -DPREB_DST3 -o sjulian3x2_b1.o \
             ATL_sJIK48x48x48TN48x48x0_a1_b1.asm
	nasm -f elf -DELF -DPREC_DST3 -DPREB_DST3 -o sjulian3x3_b1.o \
             ATL_sJIK48x48x48TN48x48x0_a1_b1.asm
	nasm -f elf -DELF -DPREC_DST4 -DPREB_DST3 -o sjulian3x4_b1.o \
             ATL_sJIK48x48x48TN48x48x0_a1_b1.asm
	nasm -f elf -DELF -DPREC_DST5 -DPREB_DST3 -o sjulian3x5_b1.o \
             ATL_sJIK48x48x48TN48x48x0_a1_b1.asm
	nasm -f elf -DELF -DPREC_DST6 -DPREB_DST3 -o sjulian3x6_b1.o \
             ATL_sJIK48x48x48TN48x48x0_a1_b1.asm
	nasm -f elf -DELF -DPREC_DST7 -DPREB_DST3 -o sjulian3x7_b1.o \
             ATL_sJIK48x48x48TN48x48x0_a1_b1.asm
	nasm -f elf -DELF -DPREC_DST1 -DPREB_DST4 -o sjulian4x1_b1.o \
             ATL_sJIK48x48x48TN48x48x0_a1_b1.asm
	nasm -f elf -DELF -DPREC_DST2 -DPREB_DST4 -o sjulian4x2_b1.o \
             ATL_sJIK48x48x48TN48x48x0_a1_b1.asm
	nasm -f elf -DELF -DPREC_DST3 -DPREB_DST4 -o sjulian4x3_b1.o \
             ATL_sJIK48x48x48TN48x48x0_a1_b1.asm
	nasm -f elf -DELF -DPREC_DST4 -DPREB_DST4 -o sjulian4x4_b1.o \
             ATL_sJIK48x48x48TN48x48x0_a1_b1.asm

=== debian/changelog ===
atlas (3.10.1-4) unstable; urgency=medium

  * libatlas3gf-base: update long description to suppress lintian warning.
  * Remove architectural defaults for obsolete s390 arch.
  * Use the new GENERIC arch name for powerpc, instead of POWER3.
    Hopefully that will fix the FTBFS on powerpc.

 -- Sébastien Villemot <sebastien@debian.org>  Mon, 03 Feb 2014 18:16:51 +0000

atlas (3.10.1-3) unstable; urgency=medium

  * libatlas-base-dev now provides liblapack.so.
  * Remove unused libatlas-3.so, libatlas-3gf.so and libatlas.so.* virtual
    packages.
  * Rewrite logic in libatlas3-base.postinst. (Closes: #719142)
  * Disable autodetection of machine type on archs for which ATLAS does not
    provide generic-enough architectural defaults. This is achieved by creating
    a GENERIC machine type (see generic.diff). In particular, this ensures that
    the package created on an armel buildd with an ARMv7 will be generic.
    (Closes: #719355)
  * Register documentation to doc-base.
  * Bump Standards-Version to 3.9.5, no changes needed.

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 29 Jan 2014 19:23:08 +0100

atlas (3.10.1-2) unstable; urgency=low

  * Allow the generic package to build on machines with CPU throttling
    enabled. Otherwise the package FTBFS on some buildds (e.g. biber).
    Implementation is done by reactivating the "-Si cputhrchk 0" flag
    (cpu-throtthling-check.diff), and using it in debian/rules.
  * Add architectural defaults for armel and mips.
  * armhf.diff: do not enforce 32-registers FPU for Fortran

 -- Sébastien Villemot <sebastien@debian.org>  Sat, 27 Jul 2013 14:26:05 +0200

atlas (3.10.1-1) experimental; urgency=low

  [ Sylvestre Ledru ]
  * New upstream release (Closes: #609287)

  [ Sébastien Villemot ]
  * Provide architectural defaults (i.e. precomputed timings) for all
    release archs (except armel and mips for the time being, due to slow
    porterboxes). This will make the package build much faster and should
    eliminate transient build failures due to excessive variance in the
    timings.
  * Move symlinks for lib{cblas,f77blas,atlas,lapack_atlas} out of the
    libblas.so.3 alternative and make them always present, so that
    software relying on these libs do not break when another alternative
    is selected for BLAS
  * ATLAS now has improved ARM support with native asm constructs. This required
    the following tunes:
    + armel-is-v4t.diff: new patch, prevents FTBFS on armel; otherwise,
      ATLAS uses asm constructs too recent for the platform (armel is only v4t)
    + debian/rules: on armhf, define the ATL_ARM_HARDFP flag; otherwise the asm
      constructs use the soft-float ABI for passing floating points
    + on armhf, ensure that -mfloat-abi=softfp and -mcpu=vfpv3 flags are never
      used; this is implemented via a patch (armhf.diff) and by the use of fixed
      archdefs
  * The generic package is now built without multi-threading, because otherwise
    the package fails to build on some single-processor machines (this required
    the introduction of a patch: fix-non-threaded-build.diff). As a side effect,
    the build of the custom package gracefully handles non-threaded
    builds. (Closes: #602524)
  * Add libblas.a as slave in the libblas.so alternative (Closes: #701921)
  * Add symlinks for lib{f77blas,atlas}.a in /usr/lib (Closes: #666203)
  * Modify shlibs file of libatlas3-base, such that packages using
    libblas/liblapack depend on any BLAS/LAPACK alternative, while packages
    depending on ATLAS-specific libraries (e.g. libatlas.so) depend specifically
    on libatlas3-base.
  * corei1.diff: remove patch, applied upstream
  * Use my @debian.org email address
  * Remove obsolete DM-Upload-Allowed flag
  * Switch VCS to git
  * Remove Conflicts/Replaces against pre-squeeze packages
  * libatlas-base-dev now provides libblas.so, as libblas-dev
  * No longer use -Wa,--noexecstack in CFLAGS, it makes the package FTBFS
  * Do not use POWER3 arch for powerpcspe port (Closes: #701068)
  * Bump to debhelper compat level 9
  * README.Debian: mention that devscripts is needed to compile the custom
    package (Closes: #697431)
  * Bump Standards-Version to 3.9.4. As a consequence, add Built-Using
    fields because the package embeds stuff from liblapack-pic

 -- Sébastien Villemot <sebastien@debian.org>  Tue, 11 Jun 2013 15:58:16 +0200

atlas (3.8.4-9.1) unstable; urgency=low

  * Non-maintainer upload.
  * libatlas3gf-base: Add Breaks: octave3.2  (Closes: #706328)
    This fixes some upgrade paths by removing the obsolete octave3.2 (and its
    triggers) a bit earlier. This is a workaround for dpkg bug #671711: dpkg
    may run trigger processing for a package even if its dependencies are not
    satisfied. The octave3.2 triggers may be run in such a state (with
    liblapack* and libblas* unpacked but unconfigured, therefore the
    alternatives may not be setup or dangling) and will fail, aborting the
    upgrade, even if octave3.2 would be removed later anyway.
    Similar Breaks exist in libblas3 and libarpack2 to cover more incarnations
    of this bug.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 28 Apr 2013 22:25:26 +0200

=== debian/control ===
Source: atlas
Section: devel
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Sylvestre Ledru <sylvestre@debian.org>,
           Sébastien Villemot <sebastien@debian.org>
Standards-Version: 3.9.5
Build-Depends: debhelper (>= 9), patch, gfortran, cdbs,
 libblas-dev (>= 1.2.20110419-3),
 liblapack-dev (>= 3.4.1), liblapack-pic (>= 3.4.1), libblas-test,
 texlive-latex-base, ghostscript, cpufrequtils
Homepage: http://math-atlas.sourceforge.net/
Vcs-Git: git://anonscm.debian.org/debian-science/packages/atlas.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/atlas.git

Package: libatlas3-base
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Provides: libblas.so.3gf, liblapack.so.3gf, libblas.so.3, liblapack.so.3
Conflicts: libblas3gf (<< 1.2-5), liblapack3gf (<< 3.2.1-4),
 libatlas3gf-base (<< 3.8.4-4)
Replaces: libblas3gf (<< 1.2.20110419-3),
 libatlas3gf-base (<< 3.8.4-4), libopenblas-base (<< 0.1.1-3),
 liblapack3gf (<< 3.4.0-1)
Breaks: libblas3gf (<< 1.2.20110419-3), libatlas3gf-base (<< 3.8.4-4),
 libopenblas-base (<< 0.1.1-3),  liblapack3gf (<< 3.4.0-1)
Suggests: liblapack3
Built-Using: ${Built-Using}
Description: Automatically Tuned Linear Algebra Software, generic shared
 ATLAS is an approach for the automatic generation and optimization of
 numerical software. Currently ATLAS supplies optimized versions for the
 complete set of linear algebra kernels known as the Basic Linear Algebra
 Subroutines (BLAS), and a subset of the linear algebra routines in the
 LAPACK library.
 .
 The libraries in this package are built without any processor extension
 instructions, and should run on all processors of this general
 architecture, albeit less than optimally.  
 . 
 Before version 3.8.3-25, optimized binary packages were provided.
 However, due to the fact that most Atlas optimisation are done at build time,
 it has been decided to remove them and give priority to locally built packages.
 . 
 For more information on how to rebuild locally atlas, see the section:
 "Building Optimized Atlas Packages on your ARCH" in README.Debian

Package: libatlas3gf-base
Section: oldlibs
Architecture: all
Depends: ${misc:Depends}, libatlas3-base
Breaks: octave3.2
Description: Transitional package to libatlas3-base
 ATLAS is an approach for the automatic generation and optimization of
 numerical software. Currently ATLAS supplies optimized versions for the
 complete set of linear algebra kernels known as the Basic Linear Algebra
 Subroutines (BLAS), and a subset of the linear algebra routines in the
 LAPACK library.
 .
 This is an empty package depending on the real library package.

Package: libatlas-base-dev
Section: libdevel
Architecture: any
Depends: libatlas3-base (= ${binary:Version}), libatlas-dev, ${misc:Depends}, 
 ${shlibs:Depends}
Provides: libblas-3gf.so, liblapack-3gf.so, liblapack-3.so, libblas.so,
 liblapack.so
Suggests: libblas-doc, liblapack-doc
Built-Using: ${Built-Using}
Description: Automatically Tuned Linear Algebra Software, generic static
 ATLAS is an approach for the automatic generation and optimization of
 numerical software. Currently ATLAS supplies optimized versions for the
 complete set of linear algebra kernels known as the Basic Linear Algebra
 Subroutines (BLAS), and a subset of the linear algebra routines in the
 LAPACK library.
 .
 This package includes the static libraries and symbolic links
 needed for program development.

Package: libatlas-dev
Section: libdevel
Architecture: all
Depends: libc6-dev, libblas-dev, ${misc:Depends}
Conflicts: libblas-dev (<< 1.2-5), liblapack-dev (<< 3.2.1-4)
Suggests: liblapack-dev, liblapack-doc
Description: Automatically Tuned Linear Algebra Software, C header files
 ATLAS is an approach for the automatic generation and optimization of
 numerical software. Currently ATLAS supplies optimized versions for the
 complete set of linear algebra kernels known as the Basic Linear Algebra
 Subroutines (BLAS), and a subset of the linear algebra routines in the
 LAPACK library.
 .
 This package provides the headers needed to compile against the libraries
 provided by ATLAS.

Package: libatlas-test
Architecture: any
Section: devel
Priority: extra
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: liblapack3
Description: Automatically Tuned Linear Algebra Software, test programs
 ATLAS is an approach for the automatic generation and optimization of
 numerical software. Currently ATLAS supplies optimized versions for the
 complete set of linear algebra kernels known as the Basic Linear Algebra
 Subroutines (BLAS), and a subset of the linear algebra routines in the
 LAPACK library.
 .
 This package provides dynamically linked testing and bench-marking
 binaries to compare the blas and atlas libraries on your system.

Package: libatlas-doc
Section: doc
Depends: ${misc:Depends}
Architecture: all
Description: Automatically Tuned Linear Algebra Software, documentation
 ATLAS is an approach for the automatic generation and optimization of
 numerical software. Currently ATLAS supplies optimized versions for the
 complete set of linear algebra kernels known as the Basic Linear Algebra
 Subroutines (BLAS), and a subset of the linear algebra routines in the
 LAPACK library.
 .
 This package provides documentation on the atlas libraries useful for
 developers.

=== debian/rules ===
#!/usr/bin/make -f
# Copyright 2008-2010 Sylvestre Ledru <sylvestre@debian.org>

include /usr/share/cdbs/1/rules/debhelper.mk

# NB: the following numbers come from xprint_enums (compilable from the build
# directory with "make xprint_enums); they can change across major releases
#
# First number in ARCHS:
# - 0 means Unknown CPU: leave ATLAS find out; used for archs where a more specific choice is not available
# - 8 means IBMz9: for s390x
# - 11 means artificial architecture called x86x87, providing you with portable (but slow!) architectural defaults: for *i386
#   See http://math-atlas.sourceforge.net/atlas_install/node28.html
# - 13 means generic libraries for P4 and later, with SSE2: for *amd64
#   See: http://math-atlas.sourceforge.net/atlas_install/node30.html
# - 36 means IA64Itan: for ia64
# - 38 means UltraSparc I (USI): for sparc
# - 46 means ARMv7: for armhf (but not for armel, which is ARM >= v4)
# - 47 means GENERIC: the same than 0 (UNKNOWN), except that it does not try autodetection
#   See debian/patches/generic.diff
# Second number in ARCHS:
# - 1 means no instruction set extension
# - 384 means SSE1+SSE2 (always available on amd64)
ifeq ($(DEB_HOST_ARCH),s390x)
ARCHS=base_8_1
else ifeq ($(DEB_HOST_ARCH_CPU),i386)
ARCHS=base_11_1
else ifeq ($(DEB_HOST_ARCH_CPU),amd64)
ARCHS=base_13_384
else ifeq ($(DEB_HOST_ARCH),ia64)
ARCHS=base_36_1
else ifeq ($(DEB_HOST_ARCH),sparc)
ARCHS=base_38_1
else ifeq ($(DEB_HOST_ARCH),armhf)
ARCHS=base_46_1
else
ARCHS=base_47_1
endif

# Pointer bitwidth
MODE_BITWIDTH = $(shell dpkg-architecture -qDEB_HOST_ARCH_BITS)

DEB_SHLIBDEPS_INCLUDE_libatlas3-base := $(CURDIR)/debian/libatlas3-base/usr/lib/atlas-base/:$(CURDIR)/debian/libatlas3-base/usr/lib/atlas-base/atlas/

DEB_DH_GENCONTROL_ARGS_ALL := -- -VBuilt-Using="`dpkg-query -W -f='$${source:Package} (= $${source:Version})' liblapack-pic`"

GFORTRAN_LIB_PATH=`$(CC) -print-search-dirs|grep ^install:|awk '{print $$2}'`

# Flags common to both the generic and custom packages
COMMON_CONFIG_PARAMS := --prefix="$(DEB_DESTDIR)" 	\
	--incdir="$(DEB_DESTDIR)/usr/include/"			\
	--libdir="$(DEB_DESTDIR)/usr/lib/$$targetName"		\
	--cc="${CC}" 									\
	--cflags="${CFLAGS}" 							\
	-D c -DWALL 									\
	-b $(MODE_BITWIDTH) 							\
	-Fa alg '-fPIC' 				\
	-Ss f77lib "-L$(GFORTRAN_LIB_PATH) -lgfortran -lgcc_s -lpthread"  \
	-Ss pmake '$(MAKE)'					\
	-Ss flapack /usr/lib/liblapack_pic.a 	\
	-A $$atlasArch									\
	-V $$atlasISA 									\
	-v 2

# See http://math-atlas.sourceforge.net/errata.html#armhardfp
ifeq ($(DEB_HOST_ARCH),armhf)
COMMON_CONFIG_PARAMS += -D c -DATL_ARM_HARDFP=1
endif

# Flags used only for the generic package
GENERIC_CONFIG_PARAMS := \
	-t 0 \
	-Ss ADdir ../../../debian/archdefs/$(DEB_HOST_ARCH_CPU) \
	-Si cputhrchk 0

# The archdefs provided by ATLAS are unsuitable for armhf (see details in
# armhf.diff patch)
#
# Hence we replace them by new ones without the problematic flags. They are
# located under debian/archdefs/arm, and used for the generic package.
#
# The following rules ensure that these new archdefs are also used for the
# custom package.
use-my-armhf-archdef:
		test -f CONFIG/ARCHS/ARMv732.tar.bz2.old || (mv CONFIG/ARCHS/ARMv732.tar.bz2 CONFIG/ARCHS/ARMv732.tar.bz2.old && cp debian/archdefs/arm/ARMv732.tar.bz2 CONFIG/ARCHS/ARMv732.tar.bz2)
		test -f CONFIG/ARCHS/ARMv732NEON.tar.bz2.old || (mv CONFIG/ARCHS/ARMv732NEON.tar.bz2 CONFIG/ARCHS/ARMv732NEON.tar.bz2.old && cp debian/archdefs/arm/ARMv732NEON.tar.bz2 CONFIG/ARCHS/ARMv732NEON.tar.bz2)

restore-armhf-archdef:
		(test -f CONFIG/ARCHS/ARMv732.tar.bz2.old && mv CONFIG/ARCHS/ARMv732.tar.bz2.old CONFIG/ARCHS/ARMv732.tar.bz2) || true
		(test -f CONFIG/ARCHS/ARMv732NEON.tar.bz2.old && mv CONFIG/ARCHS/ARMv732NEON.tar.bz2.old CONFIG/ARCHS/ARMv732NEON.tar.bz2) || true

# Build a custom package optimized for the current arch
custom: custom-stamp
.PHONY: custom
custom-stamp: use-my-armhf-archdef
		rm -f configure-stamp

		ncpu=$$(LANG=C cpufreq-info | grep "analyzing CPU" -c);\
		cpu=0;\
		while test $$cpu -lt $$ncpu ; do\
		if test $$(cpufreq-info -p 2>&1 > /dev/null; echo $$?) \
			-eq 0 -a -z "$$(LANG=C cpufreq-info -p -c $$cpu | grep performance)" ; then \
			echo "frequency governor on cpu=$$cpu is not set to 'performance'"; \
			echo "run: 'sudo cpufreq-set -g performance -c cpu#' for each cpu"; \
			echo "aborting atlas build"; \
			exit 1; \
		fi; \
		cpu=$$((cpu+1)) ;\
		done

		# Here, the trick is pretty simple:
		# * We don't want to build all the optimized version of Atlas. Just the
		#   one for the current CPU
		# * We override ARCHS by base__
		# * Base is the name of the package (libatlas3-base)
		# * __ is provided to have the right expression
		# * the regexp will consider that atlasArch and atlasISA are empty
		#   therefor, leaving the choice of the optimization to Atlas
		# * After that, we fall back to the normal build procedure by calling
		#   debian/rules itself (yep, recursively)

		# Remove all the other archs in this case
		dch --local='+custom'  "custom build on: `uname -a`"
		LANG=C debian/rules ARCHS=base__ binary
		touch $@

common-configure-arch common-configure-indep:: configure-stamp
configure-stamp:
		dh_testdir

		set -e;											\
		targetName=`echo $(ARCHS)|sed -e "s|\(.*\)_.*_.*|atlas-\1|g"`; \
		atlasArch=`echo $(ARCHS)|sed -e "s|.*_\(.*\)_.*|\1|g"`; \
		atlasISA=`echo $(ARCHS)|sed -e "s|.*_.*_\(.*\)|\1|g"`; \
		mkdir -p build/$$targetName;					\
		cd build/$$targetName; 							\
		if test "$(ARCHS)" != "base__"; then 		\
		../../configure $(COMMON_CONFIG_PARAMS) $(GENERIC_CONFIG_PARAMS); \
		else						\
		../../configure $(COMMON_CONFIG_PARAMS);	\
		fi;						\
		echo "Configure done. targetName = $$targetName / atlasArch = $$atlasArch / atlasISA = $$atlasISA";								\
		if test ! -s Make.inc; then echo "Configure failed: Make.inc not found"; exit 1; fi;											\
		cat Make.inc |grep ARCH|head -1|awk '{print $$3}'; \
		echo "=============================================="; \
		cd -
		touch $@

common-build-arch common-build-indep:: build-stamp
build-stamp:
		dh_testdir
		set -e; 												\
		targetName=`echo $(ARCHS)|sed -e "s|\(.*\)_.*_.*|atlas-\1|g"`; \
		cd build/$$targetName;									\
		$(MAKE) build;											\
		$(MAKE) check;											\
		test -f build/$$targetName/lib/libptcblas.a && $(MAKE) ptcheck;										\
		echo "==============================================";	\
		cd ../../../
		# Do not build the help when building the custom package
		if test "$(ARCHS)" != "base__"; then \
			make -C TexDoc atlas_contrib.pdf atlas_devel.pdf atlas_install.pdf cblasqref.pdf  f77blasqref.pdf lapackqref.pdf; \
		fi
		touch $@

clean:: clean-work
clean-work: restore-armhf-archdef
		dh_testdir
		dh_testroot
		rm -rf build check 
		rm -f configure-stamp build-stamp
		rm -f TexDoc/*.pdf
		[ ! -f Makefile ] || $(MAKE) distclean
.PHONY: clean-work

common-install-arch common-install-indep::
		dh_testdir
		dh_testroot

		set -e;													\
		targetName=`echo $(ARCHS)|sed -e "s|\(.*\)_.*_.*|atlas-\1|g"`; \
		cd build/$$targetName;									\
		echo "make install of $$targetName to $(DEB_DESTDIR)";	\
		$(MAKE) DESTDIR=$(DEB_DESTDIR) install;					\
		echo "=============================================";	\
		cd -

install/libatlas-dev::
	if test -d $(CURDIR)/debian/libatlas-dev/usr/include/; then \
		rm -rf $(CURDIR)/debian/libatlas-dev/usr/include/;  \
	fi
	mkdir -p $(CURDIR)/debian/libatlas-dev/usr/include/
	mv $(CURDIR)/debian/tmp/usr/include/*.h $(CURDIR)/debian/tmp/usr/include/atlas/
	mv $(CURDIR)/debian/tmp/usr/include/atlas $(CURDIR)/debian/libatlas-dev/usr/include/

install/libatlas-doc::
	if test "$(ARCHS)" != "base__"; then \
		mkdir -p $(CURDIR)/debian/libatlas-doc/usr/share/doc/libatlas-doc/; \
		cp -R $(CURDIR)/doc/* $(CURDIR)/TexDoc/*.pdf $(CURDIR)/debian/libatlas-doc/usr/share/doc/libatlas-doc/; \
	fi

# We want packages using libblas/liblapack to depend on any BLAS/LAPACK

=== debian/watch ===
version=3
http://sf.net/math-atlas/atlas(\d.*)\.tar\.bz2 debian debian/orig-tar.sh
